////////////////////////////////////////////////////////////////////////////////
//
//		Copyright (C) 2008
//				TOSHIBA TEC CORPORATION,  ALL Rights Reserved
//				2-17-2 Higashigotanda Shinagawa-ku Tokyo JAPAN
//
////////////////////////////////////////////////////////////////////////////////
//
//	FILE NAME	:	MSRPanel.java
//
//	DESCRIPTION	:	MSR Panel
//
//
//	CREATE   ON	:	V001.000			2008.02.27
//					S.Kamamoto [TEC]
//
//
////////////////////////////////////////////////////////////////////////////////

package jpostest;
import javax.swing.event.*;
import jpos.*;
import jpos.events.*;
import java.util.*;


public class MSRPanel extends javax.swing.JPanel implements ChangeListener,DataListener ,ErrorListener, StatusUpdateListener, DirectIOListener,JposConst{
    private MSR     msr;
    private java.util.List mesList;
    private MainFrame   main;
    public  boolean runFlag = false;
    
    /** Creates new form MSRPanel */
    public MSRPanel() {
        initComponents();
        jCheckBox1.setEnabled(false);
        jCheckBox2.setEnabled(false);
        jCheckBox1.addChangeListener(this);
        jCheckBox2.addChangeListener(this);

        msr = new MSR();
        mesList = new ArrayList();
        main = MainFrame.getObj();
        //jCheckBox1 = new javax.swing.JCheckBox("Decode Data",true);
        
    }
    
    public void stopDevice(){
        try{
            jCheckBox1.setEnabled(false);
            jCheckBox2.setEnabled(false);            
            jCheckBox1.setSelected(false);
            jCheckBox2.setSelected(false);            
            
            dispMes(">>>CLOSE START");
            msr.removeDataListener(this);
            msr.removeDirectIOListener(this);
            msr.removeErrorListener(this);
            msr.removeStatusUpdateListener(this);            
            msr.close();
            dispMes("<<<CLOSE SUCCESS");
            runFlag = false;
            
            dsVerLB.setText("");
            descriptionLB.setText("");
            
        }catch(JposException e){
            dispMes("!!!CLOSE ERROR : " + main.getErrorMes(e.getErrorCode()));
        }        
    }
    
    public void dispMes(String mes){
        String time;
        
        time = main.getTime();
        mesList.add(time + mes);
        
        String[] tempLis = new String[mesList.size()];

        for(int i=0; i < tempLis.length ; i++){
            tempLis[i] = (String)mesList.get(i);
        }

        jList1.setListData(tempLis);
        jList1.ensureIndexIsVisible(tempLis.length - 1);

    }
    
    public String convertByteToString(byte[] dataIn){
        String dataOut = "";
        if(dataIn == null)return "";
        
        for(int i = 0; i < dataIn.length ; i++){
            dataOut = dataOut + (char)dataIn[i];
        }
        
        return dataOut;
    }  
    
    public void setLogicalName(String name){
        deviceNameTB.setText(name);
    }
    
    //Clear List
    public void clearListData(){
        mesList.clear();        
        jList1.setListData(new String[0]);  
    }    
    
    //
    public void clearTextBox(){
        track1DataTB.setText("");
        track2DataTB.setText("");
        track3DataTB.setText("");
        track4DataTB.setText("");
        
        accountTB.setText("");
        expirationTB.setText("");
        titleTB.setText("");
        firNameTB.setText("");
        midNameTB.setText("");
        surNameTB.setText("");
        surfixTB.setText("");
        serviceCodeTB.setText("");
        track1DesTB.setText("");
        track2DesTB.setText("");        
    }
    
    //Clear Panel
    public void clearPanel(){
        deviceNameTB.setText("");
        clearListData();       
        clearTextBox();       
        jCheckBox1.setEnabled(false);
    }      
    
    
    //interface
    public void stateChanged(ChangeEvent e) {

        if(jCheckBox1.isEnabled() == true && jCheckBox2.isEnabled() == true){
            
            try{
                if(jCheckBox1.isSelected() == true && jCheckBox2.isSelected() == true)               //1.TRUE    2.TRUE
                {                                        
                    if(msr.getParseDecodeData() == false)   msr.setParseDecodeData(true);
                }
                else if(jCheckBox1.isSelected() == true && jCheckBox2.isSelected() == false)        //1.TRUE    2.FALSE
                {                 
                    
                    if(e.getSource() == jCheckBox1){
                        if(msr.getDecodeData() == false)        msr.setDecodeData(true);                  //DecedeData=FALSE set TRUE
                    }
                    else if(e.getSource() == jCheckBox2){
                        if(msr.getParseDecodeData() == true)    msr.setParseDecodeData(false);          //ParseDecedeData=TRUE  set FALSE
                    } 
                                     

                }
                else if(jCheckBox1.isSelected() == false && jCheckBox2.isSelected() == true)       //1.FALSE   2.TRUE
                {

                    if(e.getSource() == jCheckBox1){
                        jCheckBox2.setSelected(false);
                    }
                    else if(e.getSource() == jCheckBox2){
                        jCheckBox1.setSelected(true);
                    }
   
                }
                else if(jCheckBox1.isSelected() == false && jCheckBox2.isSelected() == false)      //1.FALSE   2.FALSE
                {
          
                    if(msr.getDecodeData() == true)    msr.setDecodeData(false);
                    
                }

                System.out.println("DecodeData : " + msr.getDecodeData());
                System.out.println("ParseDecodeData : " + msr.getParseDecodeData());  
                
            }catch(JposException je){}
             

        }
            
    }
     
    
    //Interface
    public void dataOccurred(DataEvent e){
        try{
            clearTextBox();
            System.out.println("DecodeData: " + msr.getDecodeData());
            System.out.println("ParseDecodeData: " + msr.getParseDecodeData());
            
            dispMes("***Data Come");
            track1DataTB.setText(convertByteToString(msr.getTrack1Data()));
            track2DataTB.setText(convertByteToString(msr.getTrack2Data()));
            track3DataTB.setText(convertByteToString(msr.getTrack3Data()));
            track4DataTB.setText(convertByteToString(msr.getTrack4Data()));
            accountTB.setText(msr.getAccountNumber());
            expirationTB.setText(msr.getExpirationDate());
            titleTB.setText(msr.getTitle());
            firNameTB.setText(msr.getFirstName());
            midNameTB.setText(msr.getMiddleInitial());
            surNameTB.setText(msr.getSurname());
            surfixTB.setText(msr.getSuffix());
            serviceCodeTB.setText(msr.getServiceCode());
            track1DesTB.setText(convertByteToString(msr.getTrack1DiscretionaryData()));
            track2DesTB.setText(convertByteToString(msr.getTrack2DiscretionaryData()));
            
        }catch(JposException er){
            
        }
    }
    
    public void errorOccurred(ErrorEvent e){
        
        clearTextBox();
        
        switch(e.getErrorCode()){
            case JPOS_E_FAILURE:
                dispMes("!!!ERROR JPOS_E_FAILURE " + " code:" + JPOS_E_FAILURE);
                break;
            case JPOS_E_EXTENDED:
                dispMes("!!!ERROR JPOS_E_EXTENDED " + " code:" + JPOS_E_EXTENDED);
                break;            
            default:
                dispMes("!!!ERROR : " + main.getErrorMes(e.getErrorCode()));
                    
        }
        
    
    }
    public void statusUpdateOccurred(StatusUpdateEvent e){  }
    public void directIOOccurred(DirectIOEvent e){  }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        jLabel4 = new javax.swing.JLabel();
        deviceNameTB = new javax.swing.JTextField();
        jPanel5 = new javax.swing.JPanel();
        jCheckBox1 = new javax.swing.JCheckBox();
        jCheckBox2 = new javax.swing.JCheckBox();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        track1DataTB = new javax.swing.JTextField();
        track2DataTB = new javax.swing.JTextField();
        track3DataTB = new javax.swing.JTextField();
        track4DataTB = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        accountTB = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        expirationTB = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        titleTB = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        surfixTB = new javax.swing.JTextField();
        surNameTB = new javax.swing.JTextField();
        jLabel12 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        firNameTB = new javax.swing.JTextField();
        midNameTB = new javax.swing.JTextField();
        jLabel16 = new javax.swing.JLabel();
        track2DesTB = new javax.swing.JTextField();
        track1DesTB = new javax.swing.JTextField();
        jLabel15 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        serviceCodeTB = new javax.swing.JTextField();
        clearList = new javax.swing.JButton();
        jLabel17 = new javax.swing.JLabel();
        dsVerLB = new javax.swing.JLabel();
        jLabel18 = new javax.swing.JLabel();
        descriptionLB = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();

        setPreferredSize(new java.awt.Dimension(580, 500));

        jPanel1.setPreferredSize(new java.awt.Dimension(770, 475));

        jPanel2.setPreferredSize(new java.awt.Dimension(100, 300));

        jLabel1.setFont(new java.awt.Font("Arial Black", 0, 24));
        jLabel1.setText("MSR");

        jPanel4.setPreferredSize(new java.awt.Dimension(580, 50));

        jButton1.setText("RUN");
        jButton1.setPreferredSize(new java.awt.Dimension(100, 30));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton2.setText("STOP");
        jButton2.setPreferredSize(new java.awt.Dimension(100, 30));
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jLabel4.setFont(new java.awt.Font("Arial", 1, 16));
        jLabel4.setText("Device Name:");
        jLabel4.setPreferredSize(new java.awt.Dimension(120, 30));

        deviceNameTB.setFont(new java.awt.Font("Arial", 0, 12));
        deviceNameTB.setPreferredSize(new java.awt.Dimension(150, 25));

        org.jdesktop.layout.GroupLayout jPanel4Layout = new org.jdesktop.layout.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jSeparator1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 550, Short.MAX_VALUE)
                    .add(jPanel4Layout.createSequentialGroup()
                        .add(jLabel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(deviceNameTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(18, Short.MAX_VALUE))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(deviceNameTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jSeparator1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 1, Short.MAX_VALUE)
                .addContainerGap(12, Short.MAX_VALUE))
        );

        jPanel5.setPreferredSize(new java.awt.Dimension(580, 211));

        jCheckBox1.setFont(new java.awt.Font("Arial", 1, 14));
        jCheckBox1.setText("Decode Data");
        jCheckBox1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox1.setPreferredSize(new java.awt.Dimension(170, 40));
        jCheckBox1.setVerticalAlignment(javax.swing.SwingConstants.BOTTOM);

        jCheckBox2.setFont(new java.awt.Font("Arial", 1, 14));
        jCheckBox2.setText("Parse Decode Data");
        jCheckBox2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox2.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox2.setPreferredSize(new java.awt.Dimension(170, 40));
        jCheckBox2.setVerticalAlignment(javax.swing.SwingConstants.BOTTOM);

        jLabel2.setFont(new java.awt.Font("Arial", 1, 14));
        jLabel2.setText("Track1Data:");
        jLabel2.setPreferredSize(new java.awt.Dimension(120, 25));

        jLabel3.setFont(new java.awt.Font("Arial", 1, 14));
        jLabel3.setText("Track2Data:");
        jLabel3.setPreferredSize(new java.awt.Dimension(120, 25));

        jLabel5.setFont(new java.awt.Font("Arial", 1, 14));
        jLabel5.setText("Track3Data:");
        jLabel5.setPreferredSize(new java.awt.Dimension(120, 25));

        jLabel6.setFont(new java.awt.Font("Arial", 1, 14));
        jLabel6.setText("Track4Data:");
        jLabel6.setPreferredSize(new java.awt.Dimension(120, 25));

        track1DataTB.setPreferredSize(new java.awt.Dimension(63, 25));

        track2DataTB.setPreferredSize(new java.awt.Dimension(63, 25));

        track3DataTB.setPreferredSize(new java.awt.Dimension(63, 25));

        track4DataTB.setPreferredSize(new java.awt.Dimension(63, 25));

        jLabel7.setFont(new java.awt.Font("Arial", 0, 11));
        jLabel7.setText("Account:");
        jLabel7.setPreferredSize(new java.awt.Dimension(50, 20));

        accountTB.setFont(new java.awt.Font("Arial", 1, 12));
        accountTB.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        accountTB.setPreferredSize(new java.awt.Dimension(100, 20));

        jLabel8.setFont(new java.awt.Font("Arial", 0, 11));
        jLabel8.setText("Expiration:");
        jLabel8.setPreferredSize(new java.awt.Dimension(50, 20));

        expirationTB.setFont(new java.awt.Font("Arial", 1, 12));
        expirationTB.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        expirationTB.setPreferredSize(new java.awt.Dimension(100, 20));

        jLabel9.setFont(new java.awt.Font("Arial", 0, 11));
        jLabel9.setText("Title:");
        jLabel9.setPreferredSize(new java.awt.Dimension(50, 20));

        titleTB.setFont(new java.awt.Font("Arial", 1, 12));
        titleTB.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        titleTB.setPreferredSize(new java.awt.Dimension(100, 20));

        jLabel13.setFont(new java.awt.Font("Arial", 0, 11));
        jLabel13.setText("Surfix:");
        jLabel13.setPreferredSize(new java.awt.Dimension(50, 20));

        surfixTB.setFont(new java.awt.Font("Arial", 1, 12));
        surfixTB.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        surfixTB.setPreferredSize(new java.awt.Dimension(100, 20));

        surNameTB.setFont(new java.awt.Font("Arial", 1, 12));
        surNameTB.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        surNameTB.setPreferredSize(new java.awt.Dimension(100, 20));

        jLabel12.setFont(new java.awt.Font("Arial", 0, 11));
        jLabel12.setText("Sur Name:");
        jLabel12.setPreferredSize(new java.awt.Dimension(50, 20));

        jLabel11.setFont(new java.awt.Font("Arial", 0, 11));
        jLabel11.setText("Mid Name:");
        jLabel11.setPreferredSize(new java.awt.Dimension(50, 20));

        jLabel10.setFont(new java.awt.Font("Arial", 0, 11));
        jLabel10.setText("Fir Name:");
        jLabel10.setPreferredSize(new java.awt.Dimension(50, 20));

        firNameTB.setFont(new java.awt.Font("Arial", 1, 12));
        firNameTB.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        firNameTB.setPreferredSize(new java.awt.Dimension(100, 20));

        midNameTB.setFont(new java.awt.Font("Arial", 1, 12));
        midNameTB.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        midNameTB.setPreferredSize(new java.awt.Dimension(100, 20));

        jLabel16.setFont(new java.awt.Font("Arial", 0, 11));
        jLabel16.setText("Trc2 Des:");
        jLabel16.setPreferredSize(new java.awt.Dimension(50, 20));

        track2DesTB.setFont(new java.awt.Font("Arial", 1, 12));
        track2DesTB.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        track2DesTB.setPreferredSize(new java.awt.Dimension(100, 20));

        track1DesTB.setFont(new java.awt.Font("Arial", 1, 12));
        track1DesTB.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        track1DesTB.setPreferredSize(new java.awt.Dimension(100, 20));

        jLabel15.setFont(new java.awt.Font("Arial", 0, 11));
        jLabel15.setText("Trc1 Des:");
        jLabel15.setPreferredSize(new java.awt.Dimension(50, 20));

        jLabel14.setFont(new java.awt.Font("Arial", 0, 11));
        jLabel14.setText("Srv code:");
        jLabel14.setPreferredSize(new java.awt.Dimension(50, 20));

        serviceCodeTB.setFont(new java.awt.Font("Arial", 1, 12));
        serviceCodeTB.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        serviceCodeTB.setPreferredSize(new java.awt.Dimension(100, 20));

        clearList.setFont(new java.awt.Font("Arial", 0, 12));
        clearList.setText("ClearList");
        clearList.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearListActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel5Layout = new org.jdesktop.layout.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel5Layout.createSequentialGroup()
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel5Layout.createSequentialGroup()
                        .addContainerGap()
                        .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel7, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 74, Short.MAX_VALUE)
                            .add(jLabel8, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 74, Short.MAX_VALUE)
                            .add(jLabel9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel13, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.CENTER)
                            .add(surfixTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(titleTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(expirationTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(accountTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(18, 18, 18)
                        .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel5Layout.createSequentialGroup()
                                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                                        .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel12, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel11, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 62, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                    .add(jLabel10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 56, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(surNameTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                        .add(midNameTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                        .add(firNameTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                                .add(18, 18, 18)
                                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                                    .add(jPanel5Layout.createSequentialGroup()
                                        .add(jLabel14, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                        .add(serviceCodeTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                    .add(jPanel5Layout.createSequentialGroup()
                                        .add(jLabel15, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 64, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                        .add(track1DesTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                    .add(jPanel5Layout.createSequentialGroup()
                                        .add(jLabel16, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                        .add(track2DesTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                            .add(clearList))
                        .add(20, 20, 20))
                    .add(jPanel5Layout.createSequentialGroup()
                        .add(8, 8, 8)
                        .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(jLabel2, 0, 0, Short.MAX_VALUE)
                            .add(jLabel3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 91, Short.MAX_VALUE))
                        .add(10, 10, 10)
                        .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel5Layout.createSequentialGroup()
                                .add(jCheckBox1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 154, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(18, 18, 18)
                                .add(jCheckBox2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 224, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(jPanel5Layout.createSequentialGroup()
                                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                                    .add(track2DataTB, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .add(track1DataTB, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 168, Short.MAX_VALUE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                    .add(jLabel6, 0, 0, Short.MAX_VALUE)
                                    .add(jLabel5, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 97, Short.MAX_VALUE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                    .add(track4DataTB, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .add(track3DataTB, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 167, Short.MAX_VALUE))))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 9, Short.MAX_VALUE)))
                .addContainerGap())
        );

        jPanel5Layout.linkSize(new java.awt.Component[] {accountTB, expirationTB, surfixTB, titleTB}, org.jdesktop.layout.GroupLayout.HORIZONTAL);

        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel5Layout.createSequentialGroup()
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(track3DataTB, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(jLabel5, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                        .add(jLabel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(track1DataTB, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel5Layout.createSequentialGroup()
                        .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(track2DataTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(track4DataTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jCheckBox1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jCheckBox2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 19, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(jLabel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel5Layout.createSequentialGroup()
                        .add(jLabel7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel8, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel13, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(surfixTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(jPanel5Layout.createSequentialGroup()
                        .add(1, 1, 1)
                        .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel5Layout.createSequentialGroup()
                                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(serviceCodeTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel14, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(track1DesTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel15, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(track2DesTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel16, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                            .add(jPanel5Layout.createSequentialGroup()
                                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(firNameTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jPanel5Layout.createSequentialGroup()
                                        .add(54, 54, 54)
                                        .add(clearList))
                                    .add(jPanel5Layout.createSequentialGroup()
                                        .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                            .add(jLabel11, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                            .add(midNameTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                        .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                            .add(surNameTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                            .add(jLabel12, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))))
                            .add(jPanel5Layout.createSequentialGroup()
                                .add(accountTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(expirationTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(titleTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))))
        );

        jPanel5Layout.linkSize(new java.awt.Component[] {jCheckBox1, jCheckBox2}, org.jdesktop.layout.GroupLayout.VERTICAL);

        jLabel17.setFont(new java.awt.Font("Arial", 1, 11));
        jLabel17.setText("DSVersion:");

        dsVerLB.setFont(new java.awt.Font("Arial", 0, 11));
        dsVerLB.setText(" ");
        dsVerLB.setPreferredSize(new java.awt.Dimension(100, 15));

        jLabel18.setFont(new java.awt.Font("Arial", 1, 11));
        jLabel18.setText("Description:");

        descriptionLB.setFont(new java.awt.Font("Arial", 0, 11));
        descriptionLB.setText(" ");
        descriptionLB.setPreferredSize(new java.awt.Dimension(380, 13));

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 578, Short.MAX_VALUE)
                    .add(jPanel2Layout.createSequentialGroup()
                        .addContainerGap()
                        .add(jLabel1)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel17)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(dsVerLB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 68, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel18)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(descriptionLB, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 290, Short.MAX_VALUE))
                    .add(jPanel5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 578, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(jLabel17)
                    .add(dsVerLB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel18)
                    .add(descriptionLB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(3, 3, 3)
                .add(jPanel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 62, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel5, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE))
        );

        jPanel3.setPreferredSize(new java.awt.Dimension(580, 169));

        jScrollPane1.setViewportView(jList1);

        org.jdesktop.layout.GroupLayout jPanel3Layout = new org.jdesktop.layout.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 550, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 185, Short.MAX_VALUE)
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(jPanel3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 570, Short.MAX_VALUE)
                    .add(jPanel2, 0, 570, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                .add(jPanel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 298, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 196, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 580, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 500, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    //Clear List
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
// TODO add your handling code here:
        stopDevice();
    }//GEN-LAST:event_jButton2ActionPerformed

    
    //Open
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
// TODO add your handling code here:
        int i = 0;
        try{
            dispMes(">>>OPEN START");
            msr.open(deviceNameTB.getText());
            dispMes("<<<OPEN SUCCESS");
            i++;
            runFlag = true;
            
            //set Properties
            dsVerLB.setText("" + msr.getDeviceServiceVersion());
            descriptionLB.setText(msr.getDeviceServiceDescription());              

            if(msr.getDecodeData()== true){
                jCheckBox1.setSelected(true);
            }
            if(msr.getParseDecodeData() == true){
                jCheckBox2.setSelected(true);
            }
            System.out.println("DecodeData : " + msr.getDecodeData());
            System.out.println("ParseDecodeData : " + msr.getParseDecodeData());            
            
            
            
            jCheckBox1.setEnabled(true);
            jCheckBox2.setEnabled(true);
            

            
            msr.addDataListener(this);
            msr.addDirectIOListener(this);
            msr.addErrorListener(this);
            msr.addStatusUpdateListener(this);
        
            dispMes(">>>Claim START");
            msr.claim(100);
            dispMes("<<<Claim SUCCESS");
            i++;
            
            dispMes(">>>DeviceEnable START");
            msr.setDeviceEnabled(true);
            dispMes("<<<DeviceEnable SUCCESS");
            i++;
            
            dispMes(">>>DataEventEnable START");
            msr.setDataEventEnabled(true);
            dispMes("<<<DataEventEnable SUCCESS");
            i++;
            
            
        }catch(JposException e){
            switch(i){
                case 0:
                    dispMes("!!!OPEN ERROR : " + main.getErrorMes(e.getErrorCode()));
                    break;
                case 1:
                    dispMes("!!!Claim ERROR : " + main.getErrorMes(e.getErrorCode()));
                    break;
                case 2:
                    dispMes("!!!DeviceEnable ERROR : " + main.getErrorMes(e.getErrorCode()));
                    break;
                case 3:
                    dispMes("!!!DataEventEnable ERROR : " + main.getErrorMes(e.getErrorCode()));
                    break;
            }
        }
        
    }//GEN-LAST:event_jButton1ActionPerformed

    private void clearListActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearListActionPerformed
        // TODO add your handling code here:
        clearListData();
}//GEN-LAST:event_clearListActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField accountTB;
    private javax.swing.JButton clearList;
    private javax.swing.JLabel descriptionLB;
    private javax.swing.JTextField deviceNameTB;
    private javax.swing.JLabel dsVerLB;
    private javax.swing.JTextField expirationTB;
    private javax.swing.JTextField firNameTB;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JCheckBox jCheckBox2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JList jList1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JTextField midNameTB;
    private javax.swing.JTextField serviceCodeTB;
    private javax.swing.JTextField surNameTB;
    private javax.swing.JTextField surfixTB;
    private javax.swing.JTextField titleTB;
    private javax.swing.JTextField track1DataTB;
    private javax.swing.JTextField track1DesTB;
    private javax.swing.JTextField track2DataTB;
    private javax.swing.JTextField track2DesTB;
    private javax.swing.JTextField track3DataTB;
    private javax.swing.JTextField track4DataTB;
    // End of variables declaration//GEN-END:variables
    
}
