////////////////////////////////////////////////////////////////////////////////
//
//		Copyright (C) 2008
//				TOSHIBA TEC CORPORATION,  ALL Rights Reserved
//				2-17-2 Higashigotanda Shinagawa-ku Tokyo JAPAN
//
////////////////////////////////////////////////////////////////////////////////
//
//	FILE NAME	:	MainFrame.java
//
//	DESCRIPTION	:	Main Frame
//
//
//	CREATE   ON	:	V001.000			2008.02.27
//					S.Kamamoto [TEC]
//                  V001.001            2008.11.28          #001
//                  Mervyn Ong CH [TSE]
//
////////////////////////////////////////////////////////////////////////////////


package jpostest;
import java.awt.CardLayout;
import java.awt.Component;
import java.util.Calendar;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.ArrayList;
import javax.swing.ImageIcon;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultTreeModel;
import jpos.JposConst;

public class MainFrame extends javax.swing.JFrame implements WindowListener ,JposConst{
    
    private DrawerPanel             drawer;
    private KeyLockPanel            keylock;
    private PKBKeyLockPanel         pkbKeylock;
    private LIUPanel                liu;
    private MSRPanel                msr;
    private ScannerPanel            scanner;
    private PrinterPanel            printer;
    private AboutPanel              about;
    private ConfiguredDevicePanel   config;
    public static MainFrame         obj;

    private ArrayList               drawerList;
    private ArrayList               keylockList;
    private ArrayList               pkbkeylockList;
    private ArrayList               liuList;
    private ArrayList               msrList;
    private ArrayList               scannerList;
    private ArrayList               printerList;
    private POSDeviceLogicalNameList DeviceNameList; //#001 to record all the jpos.xml entry logical name
    
    //#001 add tree node for each Category and Device
    DefaultMutableTreeNode nPOSDevice;    //POS device catagory
    DefaultMutableTreeNode nParentDrawer,nDrawer;
    DefaultMutableTreeNode nParentKeylock,nKeylock;
    DefaultMutableTreeNode nParentLIU,nLIU;
    DefaultMutableTreeNode nParentMSR,nMSR;
    DefaultMutableTreeNode nParentPrinter,nPrinter;
    DefaultMutableTreeNode nParentScanner,nScanner;
    DefaultMutableTreeNode nInformation;  //information catagory
    DefaultMutableTreeNode nConfigDevice,nAbout;
    
    /** Creates new form MainFrame */
    public MainFrame() {
        initComponents();
        this.setTitle("POS Test");
        obj = this;
        init();
        addWindowListener(this);
    }

     public void windowActivated(WindowEvent e){
         if((DeviceNameList.MSRLogicalNameList.size() == 0)
            && (DeviceNameList.LIULogicalNameList.size()  == 0)
            && (DeviceNameList.DrawerLogicalNameList.size() == 0)
            && (DeviceNameList.ScannerLogicalNameList.size() == 0)
            && (DeviceNameList.POSPrinterLogicalNameList.size() == 0)
            && (DeviceNameList.StandardKeylockLogicalNameList.size() == 0)
            && (DeviceNameList.ElectronicKeylockLogicalNameList.size() == 0)){
            config.readReg();
         }
     }
     public void windowClosed(WindowEvent e){
        dest();
     }
     public void windowClosing(WindowEvent e){}
     public void windowDeactivated(WindowEvent e){}
     public void windowDeiconified(WindowEvent e){}
     public void windowIconified(WindowEvent e){}
     public void windowOpened(WindowEvent e) {}
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        jPanelDisplay = new javax.swing.JPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setResizable(false);

        jPanel1.setPreferredSize(new java.awt.Dimension(800, 600));

        jPanel2.setPreferredSize(new java.awt.Dimension(800, 78));

        jLabel1.setFont(new java.awt.Font("Arial Black", 0, 36));
        jLabel1.setText("POS TEST");

        jLabel2.setFont(new java.awt.Font("Arial", 1, 18));
        jLabel2.setText("for Java POS");

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jLabel2)
                .addContainerGap(473, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 56, Short.MAX_VALUE)
                    .add(jLabel2))
                .addContainerGap())
        );

        jPanel4.setPreferredSize(new java.awt.Dimension(800, 511));

        javax.swing.tree.DefaultMutableTreeNode treeNode1 = new javax.swing.tree.DefaultMutableTreeNode("JTree");
        jTree1.setModel(new javax.swing.tree.DefaultTreeModel(treeNode1));
        jTree1.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                jTree1ValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(jTree1);

        jPanelDisplay.setPreferredSize(new java.awt.Dimension(590, 500));
        jPanelDisplay.setLayout(new java.awt.CardLayout());

        org.jdesktop.layout.GroupLayout jPanel4Layout = new org.jdesktop.layout.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel4Layout.createSequentialGroup()
                .add(10, 10, 10)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 193, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanelDisplay, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel4Layout.createSequentialGroup()
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanelDisplay, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 500, Short.MAX_VALUE))
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jPanel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 800, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(jPanel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 67, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(16, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 800, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jTree1ValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_jTree1ValueChanged

        int i;
        CardLayout cl = (CardLayout)jPanelDisplay.getLayout();
        DefaultMutableTreeNode node = (DefaultMutableTreeNode) jTree1.getLastSelectedPathComponent();

        //Nothing is selected.
        if (node == null)
            return;

        Object nodeInfo = node.getUserObject();

        // #001: Get the selected object parent node to determine the device category
        //       after that check which tree node is selected and call the respective panel to be shown
        if(node.getParent().toString().equals("Information")){          // #001 Information Category
            if(nodeInfo.toString().equals("About"))
                cl.show(jPanelDisplay, "AboutDlg");
            else if (nodeInfo.toString().equals("Configured Device"))
                cl.show(jPanelDisplay, "ConfigDlg");
        }else if(node.getParent().toString().equals("Line Display")){   // #001 Line Display Category
            for(i=0;i<DeviceNameList.LIULogicalNameList.size();i++) {
                if(nodeInfo.toString().equals( DeviceNameList.LIULogicalNameList.get(i).toString())){
                    cl.show(jPanelDisplay, DeviceNameList.LIULogicalNameList.get(i).toString());
                    break;
                }
            }
        }else if(node.getParent().toString().equals("MSR")){            // #001 MSR Category
            for(i=0;i<DeviceNameList.MSRLogicalNameList.size();i++) {
                if(nodeInfo.toString().equals( DeviceNameList.MSRLogicalNameList.get(i).toString())){
                    cl.show(jPanelDisplay, DeviceNameList.MSRLogicalNameList.get(i).toString());
                    break;
                }
            }
        }else if(node.getParent().toString().equals("Cash Drawer")){    // #001 Cash Drawer Category
             for(i=0;i<DeviceNameList.DrawerLogicalNameList.size();i++) {
                 if(nodeInfo.toString().equals(DeviceNameList.DrawerLogicalNameList.get(i).toString())){
                    cl.show(jPanelDisplay, DeviceNameList.DrawerLogicalNameList.get(i).toString());
                    break;
                 }
             }
        }else if(node.getParent().toString().equals("Scanner")){        // #001 Scanner Category
             for(i=0;i<DeviceNameList.ScannerLogicalNameList.size();i++) {
                 if(nodeInfo.toString().equals(DeviceNameList.ScannerLogicalNameList.get(i).toString())){
                    cl.show(jPanelDisplay, DeviceNameList.ScannerLogicalNameList.get(i).toString());
                    break;
                 }
             }
        }else if(node.getParent().toString().equals("POS Printer")){    // #001 POS Printer Category
             for(i=0;i<DeviceNameList.POSPrinterLogicalNameList.size();i++) {
                 if(nodeInfo.toString().equals(DeviceNameList.POSPrinterLogicalNameList.get(i).toString())){
                    cl.show(jPanelDisplay, DeviceNameList.POSPrinterLogicalNameList.get(i).toString());
                    break;
                 }
             }
        }else if(node.getParent().toString().equals("Keylock")){        // #001 Keylock Category
            // Loop for Electronic Keyboard
            for(i=0;i<DeviceNameList.ElectronicKeylockLogicalNameList.size();i++) {
                if(nodeInfo.toString().equals( DeviceNameList.ElectronicKeylockLogicalNameList.get(i).toString())){
                    cl.show(jPanelDisplay, DeviceNameList.ElectronicKeylockLogicalNameList.get(i).toString());
                    break;
                }
            }
            // Loop for Standard Keyboard
            for(i=0;i<DeviceNameList.StandardKeylockLogicalNameList.size();i++) {
                if(nodeInfo.toString().equals(DeviceNameList.StandardKeylockLogicalNameList.get(i).toString())){
                    cl.show(jPanelDisplay, DeviceNameList.StandardKeylockLogicalNameList.get(i).toString());
                    break;
                }
            }
        }
    }//GEN-LAST:event_jTree1ValueChanged
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MainFrame().setVisible(true);
            }
        });
        
    }
    
    public void init(){
        
        try{
            // #001: Create panel array list for all POS device
            liuList = new ArrayList();
            msrList = new ArrayList();
            drawerList = new ArrayList();
            scannerList = new ArrayList();
            printerList = new ArrayList();
            keylockList = new ArrayList();
            pkbkeylockList = new ArrayList();
            DeviceNameList = new POSDeviceLogicalNameList();

            // #001 create parent node, then add Information node and POS Device node into parent node
            nPOSDevice = new DefaultMutableTreeNode("POS Device Entry",true);
            nInformation = new DefaultMutableTreeNode("Information");
            nPOSDevice.add(nInformation);

            // #001 create abort dialog node, then add into Information node
            //      creating about Panel and add into jPanelDisplay with name "AbortDlg"
            nAbout = new DefaultMutableTreeNode("About");
            nInformation.add(nAbout);
            about  = new AboutPanel();
            jPanelDisplay.add(about,"AboutDlg");

            // #001 create device config node, then add into Information node
            //      creating about Panel and add into jPanelDisplay with name "ConfigDlg"
            nConfigDevice   = new DefaultMutableTreeNode("Configured Device");
            nInformation.add(nConfigDevice);
            config = new ConfiguredDevicePanel();
            jPanelDisplay.add(config,"ConfigDlg");
            pack();

            DefaultTreeModel treeModel = new DefaultTreeModel(nPOSDevice);
            jTree1.setModel(treeModel);
            jTree1.setCellRenderer(new MyRenderer());
        }catch(Exception e){
            System.out.println("Exception Occurred: " + e);
        }
    }
    
    public void dest(){
        int i;
        //Close Devices
        for(i=0;i<DeviceNameList.LIULogicalNameList.size();i++) {
            LIUPanel tempPanel = (LIUPanel)liuList.get(i);
            if(tempPanel.runFlag == true)     tempPanel.stopDevice();
            tempPanel.clearPanel();
        }
        liuList.clear();

        for(i=0;i<DeviceNameList.MSRLogicalNameList.size();i++) {
            MSRPanel tempPanel = (MSRPanel)msrList.get(i);
            if(tempPanel.runFlag == true)     tempPanel.stopDevice();
            tempPanel.clearPanel();
        }
        msrList.clear();

        for(i=0;i<DeviceNameList.ElectronicKeylockLogicalNameList.size();i++) {
            KeyLockPanel tempPanel = (KeyLockPanel)keylockList.get(i);
            if(tempPanel.runFlag == true)     tempPanel.stopDevice();
            tempPanel.clearPanel();
        }
        keylockList.clear();

        // #001 Stop PKB Keylock Device and Clear PKB keylock Panel
        for(i=0;i<DeviceNameList.StandardKeylockLogicalNameList.size();i++) {
            PKBKeyLockPanel tempPanel = (PKBKeyLockPanel)pkbkeylockList.get(i);
            if(tempPanel.runFlag == true)     tempPanel.stopDevice();
            tempPanel.clearPanel();
        }
        pkbkeylockList.clear();

        // #001 Stop Printer and Clear Printer Panel
        for(i=0;i<DeviceNameList.POSPrinterLogicalNameList.size();i++) {
            PrinterPanel tempPanel = (PrinterPanel)printerList.get(i);
            if(tempPanel.runFlag == true)     tempPanel.stopDevice();
            tempPanel.clearPanel();
        }
        printerList.clear();

        for(i=0;i<DeviceNameList.ScannerLogicalNameList.size();i++) {
            ScannerPanel tempPanel = (ScannerPanel)scannerList.get(i);
            if(tempPanel.runFlag == true)     tempPanel.stopDevice();
            tempPanel.clearPanel();
        }
        scannerList.clear();

        for(i=0;i<DeviceNameList.DrawerLogicalNameList.size();i++){
            DrawerPanel tempPanel = (DrawerPanel)drawerList.get(i);
            if(tempPanel.runFlag == true)     tempPanel.stopDevice();
            tempPanel.clearPanel();
        }
        drawerList.clear();
    }
    
   //change time
    public String getTime(){
        String year;
        String month;
        String day;
        String hour;
        String min;
        String sec;
        String send;

        Calendar cal = Calendar.getInstance();

        year    = "0000" + cal.get(Calendar.YEAR);
        month   = "00" + cal.get(Calendar.MONTH);
        day     = "00" + cal.get(Calendar.DATE);

        hour    = "00" + cal.get(Calendar.HOUR_OF_DAY);
        min     = "00" + cal.get(Calendar.MINUTE);
        sec     = "00" + cal.get(Calendar.SECOND);

        year    = year.substring(year.length()-4,year.length());
        month   = month.substring(month.length()-2,month.length());
        day     = day.substring(day.length()-2,day.length());
        hour    = hour.substring(hour.length()-2,hour.length());
        min     = min.substring(min.length()-2,min.length());
        sec     = sec.substring(sec.length()-2,sec.length());

        send = "[" + year + "-" + month + "-" + day + " " + hour +  ":" + min + "." + sec + "] ";
        return send;
    }
    
    public void setLogicalName(Object[][] data){
        // #001 define flag to control the creation of some category in POS Device Node
        boolean keylockCategory = false, scannerCategory = false, drawerCategory = false,
                printerCategory = false, liuCategory = false, msrCategory = false;
        int tempNum;


        for(int i = 0; i < data.length ; i++){
            if(data[i][0].equals("Keylock")){
                // #001 Create Keylock Category Node if it is not existed yet
                if(!keylockCategory){
                    nParentKeylock = new DefaultMutableTreeNode("Keylock");
                    nPOSDevice.add(nParentKeylock);
                    keylockCategory = true;
                }

                //#001 creating note and add into Keylock category
                 nKeylock = new DefaultMutableTreeNode((String)data[i][1]);
                 nParentKeylock.add(nKeylock);

                // #001 Check the device description to differentiate Electronic Keylock and Standard Keylock
                //      creating KeyLock/PCKKeyLock Panel and add into jPanelDisplay with its logical device name
                if(data[i][4].equals("TEC Electronic Keylock")) {
                    tempNum = DeviceNameList.ElectronicKeylockLogicalNameList.size();
                    DeviceNameList.ElectronicKeylockLogicalNameList.add((String)data[i][1]);
                    keylock = new KeyLockPanel();
                    keylock.setLogicalName(DeviceNameList.ElectronicKeylockLogicalNameList.get(tempNum).toString());
                    jPanelDisplay.add(keylock,DeviceNameList.ElectronicKeylockLogicalNameList.get(tempNum));
                }else if(data[i][4].equals("TEC Standard Keylock")){
                    tempNum = DeviceNameList.StandardKeylockLogicalNameList.size();
                    DeviceNameList.StandardKeylockLogicalNameList.add((String)data[i][1]);
                    pkbKeylock = new PKBKeyLockPanel();
                    pkbKeylock.setLogicalName(DeviceNameList.StandardKeylockLogicalNameList.get(tempNum).toString());
                    jPanelDisplay.add(pkbKeylock,DeviceNameList.StandardKeylockLogicalNameList.get(tempNum));
                }
            }else if(data[i][0].equals("LineDisplay")){
                // #001 Create Line Display Category Node if it is not existed yet
                if(!liuCategory){
                    nParentLIU = new DefaultMutableTreeNode("Line Display");
                    nPOSDevice.add(nParentLIU);
                    liuCategory = true;
                }

                //#001 creating note and add into Line Display category
                //      creating liu Panel and add into jPanelDisplay with its logical device name
                tempNum = DeviceNameList.LIULogicalNameList.size();
                DeviceNameList.LIULogicalNameList.add((String)data[i][1]);
                nLIU = new DefaultMutableTreeNode(DeviceNameList.LIULogicalNameList.get(tempNum));
                nParentLIU.add(nLIU);
                liu = new LIUPanel();
                liu.setLogicalName(DeviceNameList.LIULogicalNameList.get(tempNum).toString());
                jPanelDisplay.add(liu,DeviceNameList.LIULogicalNameList.get(tempNum));
            }else if(data[i][0].equals("MSR")){
                // #001 Create MSR Category Node if it is not existed yet
                if(!msrCategory){
                    nParentMSR = new DefaultMutableTreeNode("MSR");
                    nPOSDevice.add(nParentMSR);
                    msrCategory = true;
                }

                //#001 creating note and add into MSR category
                //     creating msr Panel and add into jPanelDisplay with its logical device name
                tempNum = DeviceNameList.MSRLogicalNameList.size();
                DeviceNameList.MSRLogicalNameList.add((String)data[i][1]);
                nMSR = new DefaultMutableTreeNode(DeviceNameList.MSRLogicalNameList.get(tempNum));
                nParentMSR.add(nMSR);
                msr = new MSRPanel();
                msr.setLogicalName(DeviceNameList.MSRLogicalNameList.get(tempNum).toString());
                jPanelDisplay.add(msr,DeviceNameList.MSRLogicalNameList.get(tempNum));
            }else if(data[i][0].equals("Scanner")){
                // #001 Create Scanner Category Node if it is not existed yet
                if(!scannerCategory){
                    nParentScanner= new DefaultMutableTreeNode("Scanner");
                    nPOSDevice.add(nParentScanner);
                    scannerCategory = true;
                }

                //#001 creating note and add into Scanner category
                //     creating scanner Panel and add into jPanelDisplay with its logical device name
                tempNum = DeviceNameList.ScannerLogicalNameList.size();
                DeviceNameList.ScannerLogicalNameList.add((String)data[i][1]);
                nScanner = new DefaultMutableTreeNode(DeviceNameList.ScannerLogicalNameList.get(tempNum));
                nParentScanner.add(nScanner);
                scanner = new ScannerPanel();
                scanner.setLogicalName(DeviceNameList.ScannerLogicalNameList.get(tempNum).toString());
                jPanelDisplay.add(scanner,DeviceNameList.ScannerLogicalNameList.get(tempNum));
            }else if(data[i][0].equals("CashDrawer")){
                // #001 Create Drawer Category Node if it is not existed yet
                if(!drawerCategory){
                    nParentDrawer= new DefaultMutableTreeNode("Cash Drawer");
                    nPOSDevice.add(nParentDrawer);
                    drawerCategory = true;
                }

                //#001 creating note and add into Drawer category
                //     creating Drawer Panel and add into jPanelDisplay with its logical device name
                tempNum = DeviceNameList.DrawerLogicalNameList.size();
                DeviceNameList.DrawerLogicalNameList.add((String)data[i][1]);
                nDrawer = new DefaultMutableTreeNode(DeviceNameList.DrawerLogicalNameList.get(tempNum));
                nParentDrawer.add(nDrawer);
                drawer = new DrawerPanel();
                drawer.setLogicalName(DeviceNameList.DrawerLogicalNameList.get(tempNum).toString());
                jPanelDisplay.add(drawer,DeviceNameList.DrawerLogicalNameList.get(tempNum));
                drawerList.add(drawer);
            }else if(data[i][0].equals("POSPrinter")){
                // #001 Create POS Printer Category Node if it is not existed yet
                if(!printerCategory){
                    nParentPrinter= new DefaultMutableTreeNode("POS Printer");
                    nPOSDevice.add(nParentPrinter);
                    printerCategory = true;
                }

                //#001 creating note and add into Printer category
                //     creating Printer Panel and add into jPanelDisplay with its logical device name
                tempNum = DeviceNameList.POSPrinterLogicalNameList.size();
                DeviceNameList.POSPrinterLogicalNameList.add((String)data[i][1]);
                nPrinter = new DefaultMutableTreeNode(DeviceNameList.POSPrinterLogicalNameList.get(tempNum));
                nParentPrinter.add(nPrinter);
                printer = new PrinterPanel();
                printer.setLogicalName(DeviceNameList.POSPrinterLogicalNameList.get(tempNum).toString());
                jPanelDisplay.add(printer,DeviceNameList.POSPrinterLogicalNameList.get(tempNum));
            }
        }
    }

     // *****************************************************************************
     // #001 Create Renderer Class to load different icon for different Category Nod
     // *****************************************************************************
    private class MyRenderer extends DefaultTreeCellRenderer {

        public MyRenderer() {
        }

        public Component getTreeCellRendererComponent(
                            JTree tree,
                            Object value,
                            boolean sel,
                            boolean expanded,
                            boolean leaf,
                            int row,
                            boolean hasFocus) {

            super.getTreeCellRendererComponent(
                            tree, value, sel,
                            expanded, leaf, row,
                            hasFocus);
            if (value.toString().equals("Cash Drawer")){
                ImageIcon Icon = new ImageIcon("icon//Drawer.gif");
                setIcon(Icon);
            }else if(value.toString().equals("Scanner")){
                ImageIcon Icon = new ImageIcon("icon//Hs380.gif");
                setIcon(Icon);
            }else if(value.toString().equals("MSR")){
                ImageIcon Icon = new ImageIcon("icon//Keycard.gif");
                setIcon(Icon);
            }else if(value.toString().equals("Line Display")){
                ImageIcon Icon = new ImageIcon("icon//Liu.gif");
                setIcon(Icon);
            }else if(value.toString().equals("Keylock")){
                ImageIcon Icon = new ImageIcon("icon//Keylock.gif");
                setIcon(Icon);
            }else if(value.toString().equals("Information")){
                ImageIcon Icon = new ImageIcon("icon//notes1.gif");
                setIcon(Icon);
            }else if(value.toString().equals("POS Device Entry")){
                ImageIcon Icon = new ImageIcon("icon//Tecpos.gif");
                setIcon(Icon);
            }else if(value.toString().equals("POS Printer")){
                ImageIcon Icon = new ImageIcon("icon//Srj.gif");
                setIcon(Icon);
            }
            return this;
        }
    }

     // *****************************************************************************
     // #001 Define a Class Structure to store the POS Device logical name
     // *****************************************************************************
    private class POSDeviceLogicalNameList {
        public ArrayList ElectronicKeylockLogicalNameList   = new ArrayList();
        public ArrayList StandardKeylockLogicalNameList     = new ArrayList();
        public ArrayList DrawerLogicalNameList              = new ArrayList();
        public ArrayList ScannerLogicalNameList             = new ArrayList();
        public ArrayList MSRLogicalNameList                 = new ArrayList();
        public ArrayList LIULogicalNameList                 = new ArrayList();
        public ArrayList POSPrinterLogicalNameList          = new ArrayList();
    }

    public String getErrorMes(int key){

        switch(key){
            case JPOS_E_CLOSED:
                return "JPOS_E_CLOSED";               
            case JPOS_E_CLAIMED:
                return "JPOS_E_CLAIMED";                
            case JPOS_E_NOTCLAIMED:
                return "JPOS_E_NOTCLAIMED";
            case JPOS_E_NOSERVICE:
                return "JPOS_E_NOSERVICE";                
            case JPOS_E_DISABLED:
                return "JPOS_E_DISABLED";
            case JPOS_E_ILLEGAL:
                return "JPOS_E_ILLEGAL";                
             case JPOS_E_NOHARDWARE:
                return "JPOS_E_NOHARDWARE";                            
            case JPOS_E_OFFLINE:
                return "JPOS_E_OFFLINE";                                
             case JPOS_E_NOEXIST:
                return "JPOS_E_NOEXIST";                               
             case JPOS_E_EXISTS:
                return "JPOS_E_EXISTS";                               
            case JPOS_E_FAILURE:
                return "JPOS_E_FAILURE";                               
            case JPOS_E_TIMEOUT:
                return "JPOS_E_TIMEOUT";                              
            case JPOS_E_BUSY:
                return "JPOS_E_BUSY";                
            case JPOS_E_EXTENDED:
                return "JPOS_E_EXTENDED";                 
        }   
        return Integer.toString(key);
    }    
    
    static public MainFrame getObj(){
        return obj;
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanelDisplay;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTree jTree1;
    // End of variables declaration//GEN-END:variables
    
}
