////////////////////////////////////////////////////////////////////////////////
//
//		Copyright (C) 2008
//				TOSHIBA TEC CORPORATION,  ALL Rights Reserved
//				2-17-2 Higashigotanda Shinagawa-ku Tokyo JAPAN
//
////////////////////////////////////////////////////////////////////////////////
//
//	FILE NAME	:	PrinterPanel.java
//
//	DESCRIPTION	:	Printer Panel
//
//
//	CREATE   ON	:	V001.000			2008.11.13
//					Antonius Kosasih [TSE]
//
//
////////////////////////////////////////////////////////////////////////////////

package jpostest;

import jpos.*;
import jpos.events.*;
import java.util.*;

/**
 *
 * @author  10107
 */
public class PrinterPanel extends javax.swing.JPanel implements jpos.POSPrinterConst,
                                                                StatusUpdateListener{
    private POSPrinter      printer;
    private java.util.List  mesList;
    private MainFrame       main;
    public  boolean         runFlag = false;
    public  String          tempStr = null; 
    public  String          strStatus = null;   
    public  String          strPaper = null; 
    public  char            temp1B[] = {0x1B};
    
    /** Creates new form PrinterPanel */
    public PrinterPanel() {
        initComponents();
        printer = new POSPrinter();
        mesList = new ArrayList();
        main    = MainFrame.getObj();
    }
    
 public void stopDevice(){
        try{
            dispMes(">>>CLOSE START");
            printer.removeStatusUpdateListener(this);            
            printer.close();
            dispMes("<<<CLOSE SUCCESS");
            runFlag = false;
            dsVerLB.setText("");
            descriptionLB.setText("");
            PaperLbl1.setText("");
            CoverLbl1.setText("");
            DrawerStatLbl1.setText("");
        }catch(JposException e){
            dispMes("!!!CLOSE ERROR : " + main.getErrorMes(e.getErrorCode()));
        }
    }
 
    public void clearPanel(){
        clearListData();       
        dsVerLB.setText("");
        descriptionLB.setText("");
        PaperLbl1.setText("");
        CoverLbl1.setText("");
        DrawerStatLbl1.setText("");             
    }     
    
    public void setLogicalName(String name){
        deviceNameTB.setText(name);
    }
    
     public void dispMes(String mes){
        String time;
        
        time = main.getTime();
        
        mesList.add(time + mes);
        
        String[] tempLis = new String[mesList.size()];

        for(int i=0; i < tempLis.length ; i++){
            tempLis[i] = (String)mesList.get(i);
        }

        jList1.setListData(tempLis);
        jList1.ensureIndexIsVisible(tempLis.length - 1);

    }
     
   public void clearListData(){
        mesList.clear();        
        jList1.setListData(new String[0]);  
    } 
    
   public void setBmpNLogo(){
   int i = 0;    
    try
    {   
        printer.setLogo(1, "Receipt No: 0251");                  
        printer.setLogo(2,"CANTEEN-------------------------Receipt No: 0251"); 
        printer.setBitmap(3, PTR_S_RECEIPT, "logo1.bmp", (printer.getRecLineWidth()),PTR_BM_CENTER); 
        printer.setBitmap(4, PTR_S_RECEIPT, "logo2.bmp", (printer.getRecLineWidth()),PTR_BM_CENTER);
        i++;
        dispMes("!!!Setting Bitmap and Logo Finished! : ");

    }
    catch (JposException e)
    {
         switch(i){
                case 0:
                  dispMes("!!!SetLogo ERROR : " + main.getErrorMes(e.getErrorCode()));
                break;
                case 1:
                  dispMes("!!!SetBitmap ERROR : " + main.getErrorMes(e.getErrorCode()));
                break;
            }    
    } 
   }
   
   public void recFront(){
       String RecStr = null;
       int i = 0;
        try{        
        tempStr = "";
        tempStr = String.valueOf(temp1B);
        tempStr += "|3B";
        printer.printNormal(PTR_S_RECEIPT, tempStr); 
                  //123456789012345678901234567890123456789012345678"  
         RecStr  = String.valueOf(temp1B);
         RecStr += "|tL\n";
         RecStr += "------------------------------------------------\n";
         RecStr += "  5 x Item1      @ $ 5.00            $    25.00 \n";
            for(int q=0; q<9; q++)
            {	
             RecStr += ("      Item2                          ");
             RecStr +="$    10.00\n";
            }
         RecStr += "      Item2                          ";
         RecStr += String.valueOf(temp1B);
         RecStr += "|2uC";
         RecStr += "$    10.00\n";
         RecStr += String.valueOf(temp1B);
         RecStr += "|3C";
         RecStr += "                           TOTAL :   $   125.00\n\n";
         RecStr += String.valueOf(temp1B);
         RecStr += "|bL\n\n";   
         printer.printNormal(PTR_S_RECEIPT, RecStr);
         printer.printBarCode(PTR_S_RECEIPT, "123456789012", PTR_BCS_EAN13, 150, 200, PTR_BM_CENTER, PTR_BC_TEXT_NONE);
         i++; 
       }
        catch(JposException e)
        {
         switch(i){
                case 0:
                  dispMes("!!!PrintNormal ERROR : " + main.getErrorMes(e.getErrorCode()));
                break;
                case 1:
                  dispMes("!!!PrintBarCode ERROR : " + main.getErrorMes(e.getErrorCode()));
                break;
            }          
        }
   }
   
   public void recDS1Front(){
       String RecStr = null;
       int i = 0;
        try{        
        tempStr = "";
        tempStr = String.valueOf(temp1B);
        tempStr += "|3B";
        printer.printNormal(PTR_S_RECEIPT, tempStr); 
                  //123456789012345678901234567890123456789012345678"  
         RecStr  = String.valueOf(temp1B);
         RecStr += "|tL\n";
         RecStr += "------------------------------------------------\n";
         RecStr += "  5 x Item1      @ $ 5.00            $    25.00 \n";
            for(int q=0; q<49; q++)
            {	
             RecStr += ("      Item2                          ");
             RecStr +="$    10.00\n";
            }
         RecStr += "      Item2                          ";
         RecStr += String.valueOf(temp1B);
         RecStr += "|2uC";
         RecStr += "$    10.00\n";
         RecStr += String.valueOf(temp1B);
         RecStr += "|3C";
         RecStr += "                           TOTAL :   $   525.00\n\n";
         RecStr += String.valueOf(temp1B);
         RecStr += "|bL\n\n";   
         printer.printNormal(PTR_S_RECEIPT, RecStr);
         printer.printBarCode(PTR_S_RECEIPT, "123456789012", PTR_BCS_EAN13, 150, 200, PTR_BM_CENTER, PTR_BC_TEXT_NONE);
         i++; 
       }
        catch(JposException e)
        {
         switch(i){
                case 0:
                  dispMes("!!!PrintNormal ERROR : " + main.getErrorMes(e.getErrorCode()));
                break;
                case 1:
                  dispMes("!!!PrintBarCode ERROR : " + main.getErrorMes(e.getErrorCode()));
                break;
            }          
        }
   }
   
   public void recBack(){
   int i = 0;
       try{
        tempStr = "";
        tempStr = String.valueOf(temp1B);
        tempStr += "|4B";
        printer.printNormal(PTR_S_RECEIPT, tempStr);     
        printer.printBarCode(PTR_S_RECEIPT, "123456789012", PTR_BCS_EAN13, 150, 200, PTR_BM_CENTER, PTR_BC_TEXT_BELOW);
        i++;
    }catch(JposException e){
         switch(i){
                case 0:
                  dispMes("!!!PrintNormal ERROR : " + main.getErrorMes(e.getErrorCode()));
                break;
                case 1:
                  dispMes("!!!PrintBarCode ERROR : " + main.getErrorMes(e.getErrorCode()));
                break;         
        }  
     }
   }
   
   
   public void FdCut(){
    try
    {   
        tempStr = "";
        tempStr = String.valueOf(temp1B);
        tempStr += "|100fP";        
        printer.printNormal(PTR_S_RECEIPT, tempStr);
    }
    catch (JposException e)
    {
        dispMes("!!!Print ERROR : " + main.getErrorMes(e.getErrorCode())); 
    }    
   }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel9 = new javax.swing.JPanel();
        jPanel10 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        dsVerLB = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        descriptionLB = new javax.swing.JLabel();
        jPanel11 = new javax.swing.JPanel();
        OpenButton1 = new javax.swing.JButton();
        CloseButton1 = new javax.swing.JButton();
        deviceNameTB = new javax.swing.JTextField();
        jPanel12 = new javax.swing.JPanel();
        DrawerStatButton1 = new javax.swing.JButton();
        OpenDrawerButton1 = new javax.swing.JButton();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        CoverLbl1 = new javax.swing.JLabel();
        PaperLbl1 = new javax.swing.JLabel();
        DrawerStatLbl1 = new javax.swing.JLabel();
        jPanel16 = new javax.swing.JPanel();
        Print1LineButton2 = new javax.swing.JButton();
        FeedNCuttButton2 = new javax.swing.JButton();
        SetBmpButton2 = new javax.swing.JButton();
        SampleRecButton2 = new javax.swing.JButton();
        PrintBmpButton2 = new javax.swing.JButton();
        jPanel17 = new javax.swing.JPanel();
        DSSetBMPButton1 = new javax.swing.JButton();
        DS1Button1 = new javax.swing.JButton();
        DS2Button1 = new javax.swing.JButton();
        RevDS2Button1 = new javax.swing.JButton();
        DS3Button1 = new javax.swing.JButton();
        DefPredefButton1 = new javax.swing.JButton();
        DelPredefButton1 = new javax.swing.JButton();
        clearList = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();

        setPreferredSize(new java.awt.Dimension(580, 500));

        jPanel9.setPreferredSize(new java.awt.Dimension(580, 500));

        jPanel10.setPreferredSize(new java.awt.Dimension(100, 300));

        jLabel3.setFont(new java.awt.Font("Arial Black", 0, 24)); // NOI18N
        jLabel3.setText("Printer");

        jLabel11.setFont(new java.awt.Font("Arial", 1, 11));
        jLabel11.setText("DSVersion:");

        dsVerLB.setFont(new java.awt.Font("Arial", 0, 11));
        dsVerLB.setText(" ");
        dsVerLB.setPreferredSize(new java.awt.Dimension(100, 15));

        jLabel12.setFont(new java.awt.Font("Arial", 1, 11));
        jLabel12.setText("Description:");

        descriptionLB.setFont(new java.awt.Font("Arial", 0, 11));
        descriptionLB.setText(" ");
        descriptionLB.setPreferredSize(new java.awt.Dimension(380, 13));

        jPanel11.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Device Name", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial Black", 0, 12), new java.awt.Color(0, 0, 0))); // NOI18N
        jPanel11.setPreferredSize(new java.awt.Dimension(244, 95));

        OpenButton1.setFont(new java.awt.Font("Arial", 1, 12)); // NOI18N
        OpenButton1.setText("Open");
        OpenButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OpenButton1ActionPerformed(evt);
            }
        });

        CloseButton1.setFont(new java.awt.Font("Arial", 1, 12)); // NOI18N
        CloseButton1.setText("Close");
        CloseButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CloseButton1ActionPerformed(evt);
            }
        });

        deviceNameTB.setFont(new java.awt.Font("Arial", 0, 12)); // NOI18N
        deviceNameTB.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        deviceNameTB.setPreferredSize(new java.awt.Dimension(150, 25));

        org.jdesktop.layout.GroupLayout jPanel11Layout = new org.jdesktop.layout.GroupLayout(jPanel11);
        jPanel11.setLayout(jPanel11Layout);
        jPanel11Layout.setHorizontalGroup(
            jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel11Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(deviceNameTB, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 198, Short.MAX_VALUE)
                    .add(jPanel11Layout.createSequentialGroup()
                        .add(OpenButton1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 90, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(18, 18, 18)
                        .add(CloseButton1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 90, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel11Layout.setVerticalGroup(
            jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel11Layout.createSequentialGroup()
                .add(deviceNameTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(OpenButton1)
                    .add(CloseButton1))
                .addContainerGap(8, Short.MAX_VALUE))
        );

        jPanel12.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "DIrectIO and Printer Status", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial Black", 0, 12), new java.awt.Color(0, 0, 0))); // NOI18N

        DrawerStatButton1.setFont(new java.awt.Font("Arial", 1, 11)); // NOI18N
        DrawerStatButton1.setText("Drawer Status");
        DrawerStatButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DrawerStatButton1ActionPerformed(evt);
            }
        });

        OpenDrawerButton1.setFont(new java.awt.Font("Arial", 1, 11)); // NOI18N
        OpenDrawerButton1.setText("Open Drawer");
        OpenDrawerButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OpenDrawerButton1ActionPerformed(evt);
            }
        });

        jLabel7.setFont(new java.awt.Font("Arial", 1, 11)); // NOI18N
        jLabel7.setText(" Cover Status");
        jLabel7.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);

        jLabel8.setFont(new java.awt.Font("Arial", 1, 11)); // NOI18N
        jLabel8.setText(" Paper Status");
        jLabel8.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);

        CoverLbl1.setFont(new java.awt.Font("Arial", 1, 11)); // NOI18N
        CoverLbl1.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        CoverLbl1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        PaperLbl1.setFont(new java.awt.Font("Arial", 1, 11)); // NOI18N
        PaperLbl1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        DrawerStatLbl1.setFont(new java.awt.Font("Arial", 1, 11)); // NOI18N
        DrawerStatLbl1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        DrawerStatLbl1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        org.jdesktop.layout.GroupLayout jPanel12Layout = new org.jdesktop.layout.GroupLayout(jPanel12);
        jPanel12.setLayout(jPanel12Layout);
        jPanel12Layout.setHorizontalGroup(
            jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel12Layout.createSequentialGroup()
                .add(jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel12Layout.createSequentialGroup()
                        .addContainerGap()
                        .add(jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 91, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel8, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 90, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(10, 10, 10)
                        .add(jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                            .add(CoverLbl1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(PaperLbl1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 104, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(jPanel12Layout.createSequentialGroup()
                        .add(1, 1, 1)
                        .add(jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, DrawerStatButton1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, OpenDrawerButton1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 114, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(DrawerStatLbl1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 96, Short.MAX_VALUE)))
                .addContainerGap())
        );

        jPanel12Layout.linkSize(new java.awt.Component[] {DrawerStatButton1, OpenDrawerButton1}, org.jdesktop.layout.GroupLayout.HORIZONTAL);

        jPanel12Layout.setVerticalGroup(
            jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel12Layout.createSequentialGroup()
                .add(jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel12Layout.createSequentialGroup()
                        .add(OpenDrawerButton1)
                        .add(2, 2, 2)
                        .add(DrawerStatButton1))
                    .add(jPanel12Layout.createSequentialGroup()
                        .add(1, 1, 1)
                        .add(DrawerStatLbl1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 47, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(CoverLbl1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel7))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel8)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, PaperLbl1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(20, Short.MAX_VALUE))
        );

        jPanel16.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Simple Test", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial Black", 0, 12), new java.awt.Color(0, 0, 0))); // NOI18N

        Print1LineButton2.setFont(new java.awt.Font("Arial", 1, 11)); // NOI18N
        Print1LineButton2.setText("Print one line");
        Print1LineButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Print1LineButton2ActionPerformed(evt);
            }
        });

        FeedNCuttButton2.setFont(new java.awt.Font("Arial", 1, 11)); // NOI18N
        FeedNCuttButton2.setText("Feed and cut");
        FeedNCuttButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FeedNCuttButton2ActionPerformed(evt);
            }
        });

        SetBmpButton2.setFont(new java.awt.Font("Arial", 1, 11)); // NOI18N
        SetBmpButton2.setText("Set&Print Bitmap");
        SetBmpButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SetBmpButton2ActionPerformed(evt);
            }
        });

        SampleRecButton2.setFont(new java.awt.Font("Arial", 1, 11)); // NOI18N
        SampleRecButton2.setText("Sample Receipt");
        SampleRecButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SampleRecButton2ActionPerformed(evt);
            }
        });

        PrintBmpButton2.setFont(new java.awt.Font("Arial", 1, 11)); // NOI18N
        PrintBmpButton2.setText("Print Bitmap");
        PrintBmpButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                PrintBmpButton2ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel16Layout = new org.jdesktop.layout.GroupLayout(jPanel16);
        jPanel16.setLayout(jPanel16Layout);
        jPanel16Layout.setHorizontalGroup(
            jPanel16Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel16Layout.createSequentialGroup()
                .add(jPanel16Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.CENTER)
                    .add(SampleRecButton2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 141, Short.MAX_VALUE)
                    .add(PrintBmpButton2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 141, Short.MAX_VALUE)
                    .add(SetBmpButton2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 141, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(FeedNCuttButton2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 141, Short.MAX_VALUE)
                    .add(Print1LineButton2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 141, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel16Layout.setVerticalGroup(
            jPanel16Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel16Layout.createSequentialGroup()
                .add(Print1LineButton2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 30, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(FeedNCuttButton2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 30, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(SetBmpButton2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 30, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(PrintBmpButton2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 30, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(11, 11, 11)
                .add(SampleRecButton2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 30, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(28, Short.MAX_VALUE))
        );

        jPanel17.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Double Side Printing", javax.swing.border.TitledBorder.LEFT, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial Black", 0, 12), new java.awt.Color(0, 0, 0))); // NOI18N
        jPanel17.setPreferredSize(new java.awt.Dimension(150, 242));

        DSSetBMPButton1.setFont(new java.awt.Font("Arial", 1, 11)); // NOI18N
        DSSetBMPButton1.setText("Set BMP & Logo");
        DSSetBMPButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        DSSetBMPButton1.setMargin(new java.awt.Insets(2, 8, 2, 8));
        DSSetBMPButton1.setMaximumSize(new java.awt.Dimension(140, 25));
        DSSetBMPButton1.setMinimumSize(new java.awt.Dimension(140, 25));
        DSSetBMPButton1.setPreferredSize(new java.awt.Dimension(140, 25));
        DSSetBMPButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DSSetBMPButton1ActionPerformed(evt);
            }
        });

        DS1Button1.setFont(new java.awt.Font("Arial", 1, 11)); // NOI18N
        DS1Button1.setText("DS w Sgl Cmd");
        DS1Button1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        DS1Button1.setMargin(new java.awt.Insets(2, 8, 2, 8));
        DS1Button1.setMaximumSize(new java.awt.Dimension(140, 25));
        DS1Button1.setMinimumSize(new java.awt.Dimension(140, 25));
        DS1Button1.setPreferredSize(new java.awt.Dimension(140, 25));
        DS1Button1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DS1Button1ActionPerformed(evt);
            }
        });

        DS2Button1.setFont(new java.awt.Font("Arial", 1, 11)); // NOI18N
        DS2Button1.setText("DS w Dbl Cmd");
        DS2Button1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        DS2Button1.setMargin(new java.awt.Insets(2, 8, 2, 8));
        DS2Button1.setMaximumSize(new java.awt.Dimension(140, 25));
        DS2Button1.setMinimumSize(new java.awt.Dimension(140, 25));
        DS2Button1.setPreferredSize(new java.awt.Dimension(140, 25));
        DS2Button1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DS2Button1ActionPerformed(evt);
            }
        });

        RevDS2Button1.setFont(new java.awt.Font("Arial", 1, 11)); // NOI18N
        RevDS2Button1.setText("Rev DS w Dbl Cmd");
        RevDS2Button1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        RevDS2Button1.setMargin(new java.awt.Insets(2, 8, 2, 8));
        RevDS2Button1.setMaximumSize(new java.awt.Dimension(140, 25));
        RevDS2Button1.setMinimumSize(new java.awt.Dimension(140, 25));
        RevDS2Button1.setPreferredSize(new java.awt.Dimension(140, 25));
        RevDS2Button1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RevDS2Button1ActionPerformed(evt);
            }
        });

        DS3Button1.setFont(new java.awt.Font("Arial", 1, 11)); // NOI18N
        DS3Button1.setText("DS w Predef. Data");
        DS3Button1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        DS3Button1.setMargin(new java.awt.Insets(2, 8, 2, 8));
        DS3Button1.setMaximumSize(new java.awt.Dimension(140, 25));
        DS3Button1.setMinimumSize(new java.awt.Dimension(140, 25));
        DS3Button1.setPreferredSize(new java.awt.Dimension(140, 25));
        DS3Button1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DS3Button1ActionPerformed(evt);
            }
        });

        DefPredefButton1.setFont(new java.awt.Font("Arial", 1, 11)); // NOI18N
        DefPredefButton1.setText("Define Predef. Data");
        DefPredefButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        DefPredefButton1.setMargin(new java.awt.Insets(2, 8, 2, 8));
        DefPredefButton1.setMaximumSize(new java.awt.Dimension(140, 25));
        DefPredefButton1.setMinimumSize(new java.awt.Dimension(140, 25));
        DefPredefButton1.setPreferredSize(new java.awt.Dimension(140, 25));
        DefPredefButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DefPredefButton1ActionPerformed(evt);
            }
        });

        DelPredefButton1.setFont(new java.awt.Font("Arial", 1, 11)); // NOI18N
        DelPredefButton1.setText("Delete Predef. Data");
        DelPredefButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        DelPredefButton1.setMargin(new java.awt.Insets(2, 8, 2, 8));
        DelPredefButton1.setMaximumSize(new java.awt.Dimension(140, 25));
        DelPredefButton1.setMinimumSize(new java.awt.Dimension(140, 25));
        DelPredefButton1.setPreferredSize(new java.awt.Dimension(140, 25));
        DelPredefButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DelPredefButton1ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel17Layout = new org.jdesktop.layout.GroupLayout(jPanel17);
        jPanel17.setLayout(jPanel17Layout);
        jPanel17Layout.setHorizontalGroup(
            jPanel17Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.CENTER, DelPredefButton1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
            .add(org.jdesktop.layout.GroupLayout.CENTER, DefPredefButton1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
            .add(org.jdesktop.layout.GroupLayout.CENTER, DS3Button1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
            .add(org.jdesktop.layout.GroupLayout.CENTER, DS2Button1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
            .add(org.jdesktop.layout.GroupLayout.CENTER, DS1Button1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
            .add(org.jdesktop.layout.GroupLayout.CENTER, DSSetBMPButton1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
            .add(org.jdesktop.layout.GroupLayout.CENTER, RevDS2Button1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        );

        jPanel17Layout.linkSize(new java.awt.Component[] {DS1Button1, DS2Button1, DS3Button1, DSSetBMPButton1, DefPredefButton1, DelPredefButton1, RevDS2Button1}, org.jdesktop.layout.GroupLayout.HORIZONTAL);

        jPanel17Layout.setVerticalGroup(
            jPanel17Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel17Layout.createSequentialGroup()
                .add(DSSetBMPButton1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(DS1Button1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(DS2Button1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(RevDS2Button1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(DS3Button1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(DefPredefButton1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(DelPredefButton1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        clearList.setFont(new java.awt.Font("Arial", 0, 12)); // NOI18N
        clearList.setText("ClearList");
        clearList.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearListActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel10Layout = new org.jdesktop.layout.GroupLayout(jPanel10);
        jPanel10.setLayout(jPanel10Layout);
        jPanel10Layout.setHorizontalGroup(
            jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel10Layout.createSequentialGroup()
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel10Layout.createSequentialGroup()
                        .add(jLabel3)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel11)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(dsVerLB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 68, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel12)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(descriptionLB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 249, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                        .add(clearList, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 91, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(jPanel10Layout.createSequentialGroup()
                            .add(jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                .add(jPanel11, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 231, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(jPanel12, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 234, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(2, 2, 2)
                            .add(jPanel16, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 152, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(3, 3, 3)
                            .add(jPanel17, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 153, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .add(5, 5, 5))
        );
        jPanel10Layout.setVerticalGroup(
            jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel10Layout.createSequentialGroup()
                .add(jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel3)
                    .add(jLabel11)
                    .add(dsVerLB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel12)
                    .add(descriptionLB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel17, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 256, Short.MAX_VALUE)
                    .add(jPanel16, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel10Layout.createSequentialGroup()
                        .add(jPanel11, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 96, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel12, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(clearList)
                .addContainerGap())
        );

        jPanel12.getAccessibleContext().setAccessibleName("DirectIO and Printer Status");

        jScrollPane2.setViewportView(jList1);

        org.jdesktop.layout.GroupLayout jPanel9Layout = new org.jdesktop.layout.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel9Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 554, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jPanel10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 563, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel9Layout.createSequentialGroup()
                .add(jPanel10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 323, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 166, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 580, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        );
    }// </editor-fold>//GEN-END:initComponents

private void clearListActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearListActionPerformed
// TODO add your handling code here:
        clearListData();
}//GEN-LAST:event_clearListActionPerformed

private void OpenButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OpenButton1ActionPerformed
// TODO add your handling code here:
  int i = 0;
  try{
    dispMes(">>>OPEN START");
    printer.open(deviceNameTB.getText());
    dispMes("<<<OPEN SUCCESS");
    i++;
    runFlag = true;
      
    //set Properties
    dsVerLB.setText("" + printer.getDeviceServiceVersion());
    descriptionLB.setText(printer.getDeviceServiceDescription());  
            
    printer.addStatusUpdateListener(this);
    
    dispMes(">>>Claim START");
    printer.claim(100);
    dispMes("<<<Claim SUCCESS");
    i++;
            
    dispMes(">>>DeviceEnable START");
    printer.setDeviceEnabled(true);
    dispMes("<<<DeviceEnable SUCCESS");
    i++;
        
        if(printer.getDeviceEnabled() == true)
        {
            int[] tempArrayInt;
            tempArrayInt = new int[1];
            printer.directIO(TPTR_CMD_DRAWER_STATUS, tempArrayInt, null);
            
            if(tempArrayInt[0] ==1)
            {
               DrawerStatLbl1.setText("<html>Drawer<br>Open</html>");
            }
            else
            {
               DrawerStatLbl1.setText("<html>Drawer<br>Close</html>");
            } 

            if(printer.getCoverOpen()==true)
            {
               strStatus = "Cover Open";
            }
            else
               strStatus = "Cover Close "; 

            CoverLbl1.setText(strStatus);

            if(printer.getRecEmpty()==true)
            {
              strPaper = "Paper Empty";        
            }
            else if(printer.getRecNearEnd()==true)
            {
               strPaper = "Paper Low";  
            }
            else
               strPaper = "Paper OK"; 

            PaperLbl1.setText(strPaper);  
        }            
    }catch(JposException e){
    switch(i){
                case 0:
                  dispMes("!!!OPEN ERROR : " + main.getErrorMes(e.getErrorCode()));
                break;
                case 1:
                  dispMes("!!!Claim ERROR : " + main.getErrorMes(e.getErrorCode()));
                  stopDevice();
                break;
                case 2:
                  dispMes("!!!DeviceEnable ERROR : " + main.getErrorMes(e.getErrorCode()));
                  stopDevice();
                break;
            }
   }
}//GEN-LAST:event_OpenButton1ActionPerformed

private void CloseButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CloseButton1ActionPerformed
// TODO add your handling code here:
    stopDevice();
    
}//GEN-LAST:event_CloseButton1ActionPerformed

private void DrawerStatButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DrawerStatButton1ActionPerformed
// TODO add your handling code here:
     int[] tempArrayInt;
     tempArrayInt = new int[1];
     try{
            printer.directIO(TPTR_CMD_DRAWER_STATUS, tempArrayInt, null);
     }catch(JposException e)
     {
           dispMes("!!!DirectIO ERROR : " + main.getErrorMes(e.getErrorCode()));        
     }
     
     if(tempArrayInt[0] ==1)
     {
         DrawerStatLbl1.setText("<html>Drawer<br>Open</html>");
     }
     else
     {
         DrawerStatLbl1.setText("<html>Drawer<br>Close</html>");
     } 
}//GEN-LAST:event_DrawerStatButton1ActionPerformed

private void OpenDrawerButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OpenDrawerButton1ActionPerformed
// TODO add your handling code here:
       int[] tempArrayInt;
       tempArrayInt = new int[1];
       tempArrayInt[0]= 0;
       try{
          printer.directIO(TPTR_CMD_DRAWER_OPEN, tempArrayInt, null);
       }catch (JposException e)
       {
          dispMes("!!!DirectIO ERROR : " + main.getErrorMes(e.getErrorCode()));     
       }     

}//GEN-LAST:event_OpenDrawerButton1ActionPerformed

private void Print1LineButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Print1LineButton2ActionPerformed
// TODO add your handling code here:
    try
    {                         //123456789012345678901234567890123456789012345678
        printer.printNormal(PTR_S_RECEIPT, "----------This is one line Printing! -----------\n");
    }
    catch (JposException e)
    {
        dispMes("!!!Print ERROR : " + main.getErrorMes(e.getErrorCode()));     
    }  
}//GEN-LAST:event_Print1LineButton2ActionPerformed

private void FeedNCuttButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_FeedNCuttButton2ActionPerformed
// TODO add your handling code here:
    FdCut();
}//GEN-LAST:event_FeedNCuttButton2ActionPerformed

private void SetBmpButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SetBmpButton2ActionPerformed
// TODO add your handling code here:
    int i = 0;    
    try
    {                         //123456789012345678901234567890123456789012345678 
        printer.setBitmap(1, PTR_S_RECEIPT, "logo1.bmp", (printer.getRecLineWidth()), PTR_BM_CENTER);   
        tempStr = "";
        tempStr = String.valueOf(temp1B);
        tempStr += "|1B";
        printer.printNormal(PTR_S_RECEIPT, tempStr);
        i++;
    }
    catch (JposException e)
    {
    switch(i){
           case 0:
              dispMes("!!!SetBitmap ERROR : " + main.getErrorMes(e.getErrorCode()));
           break;
           case 1:
              dispMes("!!!PrintNormal ERROR : " + main.getErrorMes(e.getErrorCode()));
           break;
            }            
    }       
}//GEN-LAST:event_SetBmpButton2ActionPerformed

private void PrintBmpButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_PrintBmpButton2ActionPerformed
// TODO add your handling code here:
  try
    {
        tempStr = "logo2.bmp";
        printer.printBitmap(PTR_S_RECEIPT, tempStr,printer.getRecLineWidth(), PTR_BM_CENTER);
    }
      catch (JposException e)
    {
        dispMes("!!!PrintBitmap ERROR : " + main.getErrorMes(e.getErrorCode()));    
    }     
}//GEN-LAST:event_PrintBmpButton2ActionPerformed

private void SampleRecButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SampleRecButton2ActionPerformed
// TODO add your handling code here:
    setBmpNLogo();
    recFront();
    FdCut();
}//GEN-LAST:event_SampleRecButton2ActionPerformed

private void DSSetBMPButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DSSetBMPButton1ActionPerformed
// TODO add your handling code here:
    setBmpNLogo();
}//GEN-LAST:event_DSSetBMPButton1ActionPerformed

private void DS1Button1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DS1Button1ActionPerformed
// TODO add your handling code here:
    int x = 0;
    try{
        printer.transactionPrint(PTR_S_RECEIPT, PTR_TP_TRANSACTION1);
        recDS1Front();   
        tempStr = "\n\n\n\n";
        printer.printNormal(PTR_S_RECEIPT, tempStr);  
        FdCut();
        x++;
        printer.transactionPrint(PTR_S_RECEIPT, PTR_TP_NORMAL);
    }catch(JposException e)
    {
     switch(x){
           case 0:
              dispMes("!!!TransactionPrint ERROR : " + main.getErrorMes(e.getErrorCode()));
           break;
           case 1:
              dispMes("!!!PrintNormal ERROR : " + main.getErrorMes(e.getErrorCode()));
           break;
            }     
    }    
}//GEN-LAST:event_DS1Button1ActionPerformed

private void DS2Button1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DS2Button1ActionPerformed
// TODO add your handling code here:
    int x=0;
    try{
        printer.transactionPrint(PTR_S_RECEIPT, PTR_TP_TRANSACTION2);
        x=0;
        printer.changePrintSide(PTR_PS_SIDE1);
        x=1;
        recFront();
        printer.changePrintSide(PTR_PS_SIDE2);
        x=1;
        recBack();
        printer.changePrintSide(PTR_PS_SIDE1);
        x=1;
        printer.transactionPrint(PTR_S_RECEIPT, PTR_TP_NORMAL);
        x=0;
        tempStr = "\n\n\n\n";
        printer.printNormal(PTR_S_RECEIPT, tempStr);
        x=2;
        FdCut();
    }catch(JposException e)
    {
     switch(x){
           case 0:
              dispMes("!!!TransactionPrint ERROR : " + main.getErrorMes(e.getErrorCode()));
           break;
           case 1:
              dispMes("!!!ChangePrintSide ERROR : " + main.getErrorMes(e.getErrorCode()));
           break;
           case 2:
              dispMes("!!!PrintNormal ERROR : " + main.getErrorMes(e.getErrorCode()));
           break;           
            }     
    }
}//GEN-LAST:event_DS2Button1ActionPerformed

private void RevDS2Button1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RevDS2Button1ActionPerformed
// TODO add your handling code here:
    int x=0;
       int[] tempArrayInt;
        tempArrayInt = new int[1];
        tempArrayInt[0]= 1;
    try{
        printer.directIO(TPTR_2STCMD_SWAPPRINTINGSIDE, tempArrayInt, null);
        x =3;
        printer.transactionPrint(PTR_S_RECEIPT, PTR_TP_TRANSACTION2);
        x=0;
        printer.changePrintSide(PTR_PS_SIDE1);
        x=1;
        recFront();
        printer.changePrintSide(PTR_PS_SIDE2);
        x=1;
        recBack();
        printer.changePrintSide(PTR_PS_SIDE1);
        x=1;
        printer.transactionPrint(PTR_S_RECEIPT, PTR_TP_NORMAL);
        x=0;
        tempArrayInt[0]= 0;
        printer.directIO(TPTR_2STCMD_SWAPPRINTINGSIDE, tempArrayInt, null);
        x=3;
        tempStr = "\n\n\n\n\n\n\n\n";
        printer.printNormal(PTR_S_RECEIPT, tempStr);
        x=2;
        FdCut();
    }catch(JposException e)
    {
     switch(x){
           case 0:
              dispMes("!!!TransactionPrint ERROR : " + main.getErrorMes(e.getErrorCode()));
           break;
           case 1:
              dispMes("!!!ChangePrintSide ERROR : " + main.getErrorMes(e.getErrorCode()));
           break;
           case 2:
              dispMes("!!!PrintNormal ERROR : " + main.getErrorMes(e.getErrorCode()));
           break;        
           case 3:
              dispMes("!!!DirectIO ERROR : " + main.getErrorMes(e.getErrorCode()));
           break;             
            }     
    }    
}//GEN-LAST:event_RevDS2Button1ActionPerformed

private void DS3Button1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DS3Button1ActionPerformed
// TODO add your handling code here:
    int x =0;
    
    try{
        printer.transactionPrint(PTR_S_RECEIPT, PTR_TP_TRANSACTION3);
        recFront();
        printer.transactionPrint(PTR_S_RECEIPT,  PTR_TP_NORMAL);
        tempStr = "\n\n\n\n";
        printer.printNormal(PTR_S_RECEIPT, tempStr);  
        x++;
        FdCut();
    }
    catch(JposException e)
    {
     switch(x){
           case 0:
              dispMes("!!!TransactionPrint ERROR : " + main.getErrorMes(e.getErrorCode()));
           break;
           case 1:
              dispMes("!!!PrintNormal ERROR : " + main.getErrorMes(e.getErrorCode()));
           break;
            }      
    } 
}//GEN-LAST:event_DS3Button1ActionPerformed

private void DefPredefButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DefPredefButton1ActionPerformed
// TODO add your handling code here:
 try{      
        printer.transactionPrint(PTR_S_RECEIPT, PTR_TP_PREDEFINE);
        tempStr = "";
        tempStr = String.valueOf(temp1B);
        tempStr += "|3B";
        printer.printNormal(PTR_S_RECEIPT, tempStr);
        printer.printBarCode(PTR_S_RECEIPT, "123456789012", PTR_BCS_PDF417 , 75,(printer.getRecLineWidth()/2) , PTR_BM_CENTER, PTR_BC_TEXT_BELOW);
        tempStr = "";
        tempStr = String.valueOf(temp1B);
        tempStr += "|4B";
        printer.printNormal(PTR_S_RECEIPT, tempStr);
        printer.printBarCode(PTR_S_RECEIPT, "210987654321", PTR_BCS_UPCA, 75,(printer.getRecLineWidth()) , PTR_BM_CENTER, PTR_BC_TEXT_BELOW);
        printer.transactionPrint(PTR_S_RECEIPT,  PTR_TP_NORMAL);
        dispMes("!!!Defining Predifene Data Success!" );         
    }
    catch(JposException e)
    {
        dispMes("!!!Defining Predifene Data ERROR : " + main.getErrorMes(e.getErrorCode()));  
    }    
}//GEN-LAST:event_DefPredefButton1ActionPerformed

private void DelPredefButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DelPredefButton1ActionPerformed
// TODO add your handling code here:
 try{      
        printer.transactionPrint(PTR_S_RECEIPT, PTR_TP_PREDEFINE);
        printer.printNormal(PTR_S_RECEIPT, "");
        printer.transactionPrint(PTR_S_RECEIPT, PTR_TP_NORMAL);
        dispMes("!!!Deleting Predifene Data Success!" );         
    }
    catch(JposException e)
    {
        dispMes("!!!Deleting Predifene Data ERROR : " + main.getErrorMes(e.getErrorCode()));  
    }       
}//GEN-LAST:event_DelPredefButton1ActionPerformed

   public void statusUpdateOccurred(StatusUpdateEvent arg0) {

    try
    {
        if(printer.getCoverOpen()==true)
            strStatus = "Cover Open";
        else
           strStatus = "Cover Close ";
        CoverLbl1.setText(strStatus);

        if(printer.getRecEmpty()==true)
            strPaper = "Paper Empty";
        else if(printer.getRecNearEnd()==true)
            strPaper = "Paper Low";
        else
            strPaper = "Paper OK";

        PaperLbl1.setText(strPaper);
    }
    catch(JposException e){ }

    }
/////////////////////////////////////////////
// TEC Printer constants definition        //
/////////////////////////////////////////////
// 2ST ?TransactionPrint?Method: ?Control Parameter Constants
public static final int PTR_TP_TRANSACTION1 = 411;
public static final int PTR_TP_TRANSACTION2 = 511;
public static final int PTR_TP_TRANSACTION3 = 611;
public static final int PTR_TP_PREDEFINE = 711;
// dual side printing definition
public static final int TPTR_2STCMD_SET_PRINTINGMODE = 101;
public static final int TPTR_2STCMD_SET_PRINTINGSIDE = 102;
public static final int TPTR_2STCMD_SET_UPSIDEDOWN = 103;
public static final int TPTR_2STCMD_SWAPPRINTINGSIDE = 104;
public static final int TPTR_2STCMD_PREDEFINE = 105;
// drawer control definition
public static final int TPTR_CMD_DRAWER_OPEN = 111;
public static final int TPTR_CMD_DRAWER_STATUS = 112;

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton CloseButton1;
    private javax.swing.JLabel CoverLbl1;
    private javax.swing.JButton DS1Button1;
    private javax.swing.JButton DS2Button1;
    private javax.swing.JButton DS3Button1;
    private javax.swing.JButton DSSetBMPButton1;
    private javax.swing.JButton DefPredefButton1;
    private javax.swing.JButton DelPredefButton1;
    private javax.swing.JButton DrawerStatButton1;
    private javax.swing.JLabel DrawerStatLbl1;
    private javax.swing.JButton FeedNCuttButton2;
    private javax.swing.JButton OpenButton1;
    private javax.swing.JButton OpenDrawerButton1;
    private javax.swing.JLabel PaperLbl1;
    private javax.swing.JButton Print1LineButton2;
    private javax.swing.JButton PrintBmpButton2;
    private javax.swing.JButton RevDS2Button1;
    private javax.swing.JButton SampleRecButton2;
    private javax.swing.JButton SetBmpButton2;
    private javax.swing.JButton clearList;
    private javax.swing.JLabel descriptionLB;
    private javax.swing.JTextField deviceNameTB;
    private javax.swing.JLabel dsVerLB;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JList jList1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel16;
    private javax.swing.JPanel jPanel17;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane2;
    // End of variables declaration//GEN-END:variables

}
