////////////////////////////////////////////////////////////////////////////////
//
//		Copyright (C) 2008
//				TOSHIBA TEC CORPORATION,  ALL Rights Reserved
//				2-17-2 Higashigotanda Shinagawa-ku Tokyo JAPAN
//
////////////////////////////////////////////////////////////////////////////////
//
//	FILE NAME	:	ScannerPanel.java
//
//	DESCRIPTION	:	Scanner Panel
//
//
//	CREATE   ON	:	V001.000			2008.02.27
//					S.Kamamoto [TEC]
//
//
////////////////////////////////////////////////////////////////////////////////


package jpostest;
import jpos.*;
import jpos.events.*;
import javax.swing.JCheckBox;
import java.util.*;
import javax.swing.event.*;
import jpos.ScannerConst;


public class ScannerPanel extends javax.swing.JPanel implements ChangeListener,DataListener, StatusUpdateListener, DirectIOListener, ErrorListener,ScannerConst{
    private Scanner         scanner;
    private java.util.List  mesList;
    private MainFrame       main;
    public  boolean runFlag = false;
    
    /** Creates new form ScannerPanel */
    public ScannerPanel() {
        initComponents();
        jCheckBox1.addChangeListener(this);
        jCheckBox1.setEnabled(false);
        scanner = new Scanner();
        mesList = new ArrayList();
        main    = MainFrame.getObj();
    }
    public void stopDevice(){
        try{
            

            dispMes(">>>CLOSE START");
            scanner.removeDataListener(this);
            scanner.removeDirectIOListener(this);
            scanner.removeErrorListener(this);
            scanner.removeStatusUpdateListener(this);            
            scanner.close();
            dispMes("<<<CLOSE SUCCESS");
            runFlag = false;
            
            
            
            scanDataTypeTB.setText("");
            scanDataLabelTB.setText("");
            dsVerLB.setText("");
            descriptionLB.setText("");
            scanDataTB.setText("");
            jCheckBox1.setSelected(false);
            jCheckBox1.setEnabled(false);
        }catch(JposException e){
            dispMes("!!!CLOSE ERROR : " + main.getErrorMes(e.getErrorCode()));
        }
    }
    public void dispMes(String mes){
        String time;
        
        time = main.getTime();
        
        mesList.add(time + mes);
        
        String[] tempLis = new String[mesList.size()];

        for(int i=0; i < tempLis.length ; i++){
            tempLis[i] = (String)mesList.get(i);
        }

        jList1.setListData(tempLis);
        jList1.ensureIndexIsVisible(tempLis.length - 1);

    }
    
    public void setLogicalName(String name){
        deviceNameTB.setText(name);
    }

    //Clear List
    public void clearListData(){
        mesList.clear();        
        jList1.setListData(new String[0]);  
    } 
    //Clear TextBox
    public void clearTextBox(){
        scanDataLabelTB.setText("");
        scanDataTB.setText("");
        scanDataTypeTB.setText("");
    }
    
    //Clear Panel
    public void clearPanel(){
        clearListData();
        deviceNameTB.setText("");
        
        clearTextBox();
        
        jCheckBox1.setEnabled(false);
    }           
    
    //Interface
    public void dataOccurred(DataEvent e){
        try{
            clearTextBox();
            dispMes("***Data Come");
            System.out.println("type : " + Integer.toString(scanner.getScanDataType()));
            System.out.println("label : " + convertByteToString(scanner.getScanDataLabel()));            
            System.out.println("data : " + convertByteToString(scanner.getScanData()));      
            
            scanDataTypeTB.setText(getScanTypeLabel(scanner.getScanDataType()));    
            //scanDataTypeTB.setText(Integer.toString(scanner.getScanDataType()));
            scanDataLabelTB.setText(convertByteToString(scanner.getScanDataLabel()));
            scanDataTB.setText(convertByteToString(scanner.getScanData()));
            
        }catch(JposException je){}
    }
    
    
    public String getScanTypeLabel(int num){
        String data = null;
        
        switch(num){
            case SCAN_SDT_UPCA:
                    data = "SCAN_SDT_UPCA";
                    break;
            
            case SCAN_SDT_UPCA_S:
                    data = "SCAN_SDT_UPCA_S";
                    break;
                    
            case SCAN_SDT_UPCE:
                    data = "SCAN_SDT_UPCE";
                    break;
                    
            case SCAN_SDT_UPCE_S:
                    data = "SCAN_SDT_UPCE_S";
                    break;
                    
            case SCAN_SDT_UPCD1:
                    data = "SCAN_SDT_UPCD1";
                    break;
                    
            case SCAN_SDT_UPCD2:
                    data = "SCAN_SDT_UPCD2";
                    break;
                    
            case SCAN_SDT_UPCD3:
                    data = "SCAN_SDT_UPCD3"; 
                    break;
                    
            case SCAN_SDT_UPCD4:
                    data = "SCAN_SDT_UPCD4";
                    break;
                    
            case SCAN_SDT_UPCD5:
                    data = "SCAN_SDT_UPCD5";
                    break;
                    
            case SCAN_SDT_EAN8:
                    data = "SCAN_SDT_EAN8";
                    break;
                    
            case SCAN_SDT_EAN8_S:
                    data = "SCAN_SDT_EAN8_S";
                    break;
                    
            case SCAN_SDT_EAN13:
                    data = "SCAN_SDT_EAN13";
                    break;
                    
            case SCAN_SDT_EAN13_S:
                    data = "SCAN_SDT_EAN13_S";
                    break;
                    
            case SCAN_SDT_EAN128:
                    data = "SCAN_SDT_EAN128";
                    break;
                    
            case SCAN_SDT_TF:
                    data = "SCAN_SDT_TF";
                    break;
                    
            case SCAN_SDT_ITF:
                    data = "SCAN_SDT_ITF";
                    break;
                    
            case SCAN_SDT_Codabar:
                    data = "SCAN_SDT_Codabar";
                    break;
                    
            case SCAN_SDT_Code39:
                    data = "SCAN_SDT_Code39";
                    break;
                    
            case SCAN_SDT_Code93:
                    data = "SCAN_SDT_Code93";
                    break;
                    
            case SCAN_SDT_Code128:
                    data = "SCAN_SDT_Code128";
                    break;
                    
            case SCAN_SDT_OCRA:
                    data = "SCAN_SDT_OCRA";
                    break;
                    
            case SCAN_SDT_OCRB:
                    data = "SCAN_SDT_OCRB";
                    break;
                    
            case SCAN_SDT_PDF417:
                    data = "SCAN_SDT_PDF417";
                    break;
                    
            case SCAN_SDT_MAXICODE:
                    data = "SCAN_SDT_MAXICODE";
                    break;         
        }

        return data;
    }
    public void statusUpdateOccurred(StatusUpdateEvent e){}
    public void directIOOccurred(DirectIOEvent e){}
    public void errorOccurred(ErrorEvent e){
        clearTextBox();
    }
    
    
    public void stateChanged(ChangeEvent e) {

        if(jCheckBox1.isEnabled() == true){
            if (jCheckBox1.isSelected() == true) {
                try{
                    scanner.setDecodeData(true);
                }catch(JposException je){}
            }else{
                try{
                    scanner.setDecodeData(false);
                }catch(JposException je){}
            }
        }
    }
    public String convertByteToString(byte[] dataIn){
        String dataOut = "";
        if(dataIn == null)return "";
        
        for(int i = 0; i < dataIn.length ; i++){
            dataOut = dataOut + (char)dataIn[i];
        }
        
        return dataOut;
    }    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        jLabel4 = new javax.swing.JLabel();
        deviceNameTB = new javax.swing.JTextField();
        jPanel5 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        scanDataTypeTB = new javax.swing.JTextField();
        scanDataLabelTB = new javax.swing.JTextField();
        scanDataTB = new javax.swing.JTextField();
        jCheckBox1 = new javax.swing.JCheckBox();
        jLabel5 = new javax.swing.JLabel();
        dsVerLB = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        descriptionLB = new javax.swing.JLabel();
        jPanel6 = new javax.swing.JPanel();
        clearList = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();

        setPreferredSize(new java.awt.Dimension(590, 500));

        jPanel1.setPreferredSize(new java.awt.Dimension(770, 475));

        jPanel2.setPreferredSize(new java.awt.Dimension(100, 300));

        jLabel1.setFont(new java.awt.Font("Arial Black", 0, 24));
        jLabel1.setText("Scanner");

        jPanel4.setPreferredSize(new java.awt.Dimension(100, 50));

        jButton1.setText("RUN");
        jButton1.setPreferredSize(new java.awt.Dimension(100, 30));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton2.setText("STOP");
        jButton2.setPreferredSize(new java.awt.Dimension(100, 30));
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jLabel4.setFont(new java.awt.Font("Arial", 1, 16));
        jLabel4.setText("Device Name:");
        jLabel4.setPreferredSize(new java.awt.Dimension(120, 30));

        deviceNameTB.setFont(new java.awt.Font("Arial", 0, 12));
        deviceNameTB.setPreferredSize(new java.awt.Dimension(150, 25));

        org.jdesktop.layout.GroupLayout jPanel4Layout = new org.jdesktop.layout.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jSeparator1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 560, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jPanel4Layout.createSequentialGroup()
                        .add(jLabel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(deviceNameTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(deviceNameTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jSeparator1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 10, Short.MAX_VALUE))
        );

        jLabel2.setFont(new java.awt.Font("Arial", 1, 16));
        jLabel2.setText("ScanDataLabel:");
        jLabel2.setPreferredSize(new java.awt.Dimension(150, 25));

        jLabel3.setFont(new java.awt.Font("Arial", 1, 16));
        jLabel3.setText("ScanDataType:");
        jLabel3.setPreferredSize(new java.awt.Dimension(150, 25));

        jLabel6.setFont(new java.awt.Font("Arial", 1, 16));
        jLabel6.setText("ScanData:");
        jLabel6.setPreferredSize(new java.awt.Dimension(150, 25));

        scanDataTypeTB.setFont(new java.awt.Font("Arial", 0, 14));
        scanDataTypeTB.setPreferredSize(new java.awt.Dimension(200, 25));

        scanDataLabelTB.setFont(new java.awt.Font("Arial", 0, 14));
        scanDataLabelTB.setPreferredSize(new java.awt.Dimension(200, 25));

        scanDataTB.setFont(new java.awt.Font("Arial", 0, 14));
        scanDataTB.setPreferredSize(new java.awt.Dimension(200, 25));

        jCheckBox1.setFont(new java.awt.Font("Arial", 1, 16)); // NOI18N
        jCheckBox1.setText("Decode Data");
        jCheckBox1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox1.setPreferredSize(new java.awt.Dimension(115, 40));
        jCheckBox1.setVerticalAlignment(javax.swing.SwingConstants.BOTTOM);

        org.jdesktop.layout.GroupLayout jPanel5Layout = new org.jdesktop.layout.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel5Layout.createSequentialGroup()
                        .add(jLabel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(scanDataLabelTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jPanel5Layout.createSequentialGroup()
                        .add(jLabel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(scanDataTypeTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jPanel5Layout.createSequentialGroup()
                        .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jCheckBox1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel6, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(scanDataTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(22, Short.MAX_VALUE))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(scanDataTypeTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(scanDataLabelTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(scanDataTB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jCheckBox1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(42, Short.MAX_VALUE))
        );

        jLabel5.setFont(new java.awt.Font("Arial", 1, 11));
        jLabel5.setText("DSVersion:");

        dsVerLB.setFont(new java.awt.Font("Arial", 0, 11)); // NOI18N
        dsVerLB.setText(" ");
        dsVerLB.setPreferredSize(new java.awt.Dimension(100, 15));

        jLabel7.setFont(new java.awt.Font("Arial", 1, 11));
        jLabel7.setText("Description:");

        descriptionLB.setFont(new java.awt.Font("Arial", 0, 11)); // NOI18N
        descriptionLB.setText(" ");
        descriptionLB.setPreferredSize(new java.awt.Dimension(380, 13));

        clearList.setFont(new java.awt.Font("Arial", 0, 12));
        clearList.setText("ClearList");
        clearList.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearListActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel6Layout = new org.jdesktop.layout.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel6Layout.createSequentialGroup()
                .addContainerGap(78, Short.MAX_VALUE)
                .add(clearList)
                .add(23, 23, 23))
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel6Layout.createSequentialGroup()
                .addContainerGap(166, Short.MAX_VALUE)
                .add(clearList))
        );

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel2Layout.createSequentialGroup()
                .add(jPanel5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 18, Short.MAX_VALUE)
                .add(jPanel6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
            .add(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jLabel5)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(dsVerLB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 68, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jLabel7)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(descriptionLB, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 243, Short.MAX_VALUE)
                .addContainerGap())
            .add(jPanel2Layout.createSequentialGroup()
                .add(jPanel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 580, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(jLabel5)
                    .add(dsVerLB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel7)
                    .add(descriptionLB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 64, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel5, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jPanel6, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
        );

        jPanel3.setPreferredSize(new java.awt.Dimension(580, 169));

        jScrollPane1.setViewportView(jList1);

        org.jdesktop.layout.GroupLayout jPanel3Layout = new org.jdesktop.layout.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 560, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 580, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(jPanel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 590, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 500, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    //Clear List
    private void clearListActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearListActionPerformed
// TODO add your handling code here:
        clearListData();
    }//GEN-LAST:event_clearListActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
// TODO add your handling code here:
        stopDevice();
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
// TODO add your handling code here:
        int i = 0;
        try{
            dispMes(">>>OPEN START");
            scanner.open(deviceNameTB.getText());
            dispMes("<<<OPEN SUCCESS");
            i++;
            runFlag = true;
            jCheckBox1.setEnabled(true);
            
            if(scanner.getDecodeData() == true){
                jCheckBox1.setSelected(true);
            }
            
            //set Properties
            dsVerLB.setText("" + scanner.getDeviceServiceVersion());
            descriptionLB.setText(scanner.getDeviceServiceDescription());  
            
            
            scanner.addDataListener(this);
            scanner.addDirectIOListener(this);
            scanner.addErrorListener(this);
            scanner.addStatusUpdateListener(this);

            
            dispMes(">>>Claim START");
            scanner.claim(100);
            dispMes("<<<Claim SUCCESS");
            i++;
            
            
            dispMes(">>>DeviceEnable START");
            scanner.setDeviceEnabled(true);
            dispMes("<<<DeviceEnable SUCCESS");
            i++;
            
            dispMes(">>>DataEventEnable START");
            scanner.setDataEventEnabled(true);
            dispMes("<<<DataEventEnable SUCCESS");
            i++;       
        }catch(JposException e){
            switch(i){
                case 0:
                    dispMes("!!!OPEN ERROR : " + main.getErrorMes(e.getErrorCode()));
                    break;
                case 1:
                    dispMes("!!!Claim ERROR : " + main.getErrorMes(e.getErrorCode()));
                    break;
                case 2:
                    dispMes("!!!DeviceEnable ERROR : " + main.getErrorMes(e.getErrorCode()));
                    break;
                case 3:
                    dispMes("!!!DataEventEnable ERROR : " + main.getErrorMes(e.getErrorCode()));
                    break;
            }
        }
    }//GEN-LAST:event_jButton1ActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton clearList;
    private javax.swing.JLabel descriptionLB;
    private javax.swing.JTextField deviceNameTB;
    private javax.swing.JLabel dsVerLB;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JList jList1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JTextField scanDataLabelTB;
    private javax.swing.JTextField scanDataTB;
    private javax.swing.JTextField scanDataTypeTB;
    // End of variables declaration//GEN-END:variables
    
}
